const fs = require("fs");
export const mockLoadResult = () => ({
    data: {
        contentItem: {
            config: {
                id: "1",
                elements: {
                    "pie-multiple-choice": "@pie-element/multiple-choice@2.8.4",
                },
                models: [
                    {
                        id: "1",
                        element: "pie-multiple-choice",
                    },
                ],
                markup: "<pie-multiple-choice id='1'></pie-multiple-choice>",
            },
        },
    },
});
export const mockAllSanctionedBuildVersions = () => ({
    data: {
        findAllBestVersions: [
            { name: "@pie-element/multiple-choice", version: "1.0.0" },
            { name: "@pie-element/extended-text-entry", version: "1.0.0" },
        ],
    },
});
export const releaseContentItem = () => ({
    data: {
        releaseContentItem: {
            id: "abc",
            version: {
                major: 0,
                minor: 0,
                patch: 1,
            },
        },
    },
});
export const mockSaveResult = () => ({
    data: {
        saveContentItem: {
            id: "abc",
            version: {
                major: 0,
                minor: 0,
                patch: 1,
                prerelease: {
                    tag: "draft",
                    version: 0,
                },
            },
        },
    },
});
export const loadPlayerResult = () => ({
    session: {
        id: "1",
        data: [],
    },
    js: {
        view: [
            "https://pits-dot-pie-dev-221718.appspot.com/bundles/@pie-element/multiple-choice@latest/player.js",
        ],
    },
    item: {
        models: [
            {
                disabled: false,
                mode: "gather",
                prompt: '<div>Read the paragraph.<br /><br /><table><tr><td style="border:solid 1px black;"><p class="kds-indent"> Pie is the best dessert.&#160; Pie can be made from different types of fruit.&#160; Cake is good too.&#160; The best pie is cherry.</p></td></tr></table><br />Which sentence does NOT belong in the paragraph?</div>',
                choiceMode: "radio",
                shuffle: true,
                choices: [
                    {
                        label: "<p>The best pie is cherry.</p>",
                        value: "8a80808163e9a4a80163ec6a467739c9",
                    },
                    {
                        label: "<p>Pie is the best dessert.</p>",
                        value: "8a80808163e9a4a80163ec6a467739c6",
                    },
                    {
                        label: "<p>Cake is good too.</p>",
                        value: "8a80808163e9a4a80163ec6a467739c8",
                    },
                    {
                        label: "<p>Pie can be made from different types of fruit.</p>",
                        value: "8a80808163e9a4a80163ec6a467739c7",
                    },
                ],
                complete: {
                    min: 1,
                },
                element: "pie-multiple-choice",
                id: "8a80808163e9a4a80163ec6a467739c3",
            },
        ],
        elements: {
            "pie-multiple-choice": "@pie-element/multiple-choice@latest",
        },
        id: "b79cce11-c9ef-49f9-a5b7-191db691a5ee",
        markup: '<pie-multiple-choice id="8a80808163e9a4a80163ec6a467739c3"></pie-multiple-choice>',
    },
});
export const loadPlayerResultStimulusItem = () => ({
    session: {
        id: "1",
        data: [],
    },
    js: {
        view: [
            "https://pits-dot-pie-dev-221718.appspot.com/bundles/mock-path/player.js",
        ],
    },
    item: {
        pie: {
            id: "1",
            elements: {
                "pie-multiple-choice": "@pie-element/multiple-choice@2.7.3",
            },
            models: [
                {
                    id: "1",
                    element: "pie-multiple-choice",
                    prompt: "What is the theme of this poem?",
                    choiceMode: "checkbox",
                    keyMode: "numbers",
                    choices: [
                        {
                            correct: true,
                            value: "sorrow",
                            label: "Sorrow",
                            feedback: {
                                type: "none",
                                value: "",
                            },
                        },
                        {
                            value: "contemplation",
                            label: "Contemplation",
                            feedback: {
                                type: "none",
                                value: "",
                            },
                        },
                        {
                            value: "loneliness",
                            label: "Loneliness",
                            feedback: {
                                type: "none",
                                value: "",
                            },
                        },
                        {
                            correct: true,
                            value: "envy",
                            label: "Envy",
                            feedback: {
                                type: "none",
                                value: "",
                            },
                        },
                    ],
                    partialScoring: false,
                    partialScoringLabel: `Each correct response that is correctly checked and each incorrect response
            that is correctly unchecked will be worth 1 point.
            The maximum points is the total number of answer choices.`,
                },
            ],
            markup: `
          <pie-multiple-choice id='1'></pie-multiple-choice>
        `,
        },
        passage: {
            id: "1",
            elements: {
                "pie-passage": "@pie-element/passage@latest",
            },
            models: [
                {
                    id: "1",
                    element: "pie-passage",
                    title: "Ineskeen Road, July Evening",
                    content: `The bicycles go by in twos and threes -<br/>
        There's a dance in Billy Brennan's barn tonight,<br/>
        And there's the half-talk code of mysteries<br/>
        And the wink-and-elbow language of delight.<br/>
        Half-past eight and there is not a spot<br/>
        Upon a mile of road, no shadow thrown<br/>
        That might turn out a man or woman, not<br/>
        A footfall tapping secrecies of stone. <br/>
        <p/>
        I have what every poet hates in spite<br/>
        Of all the solemn talk of contemplation.<br/>
        Oh, Alexander Selkirk knew the plight<br/>
        Of being king and government and nation.<br/>
        A road, a mile of kingdom. I am king<br/>
        Of banks and stones and every blooming thing.<br/>
        `,
                },
            ],
            markup: `
          <pie-passage id='1'></pie-passage>
        `,
        },
    },
});
const mockPieCloudResponseContent = fs.readFileSync(__dirname + "/mock-build-service-response.js");
export const mockBuildServiceResponse = () => {
    return mockPieCloudResponseContent;
};
