export const availablePies = {
    'pie-multiple-choice': {
        name: 'Multiple Choice',
        piePackage: '@pie-element/multiple-choice',
        defaults: {
            choiceMode: 'radio'
        }
    },
    'pie-multiple-select': {
        name: 'Multiple Select',
        piePackage: '@pie-element/multiple-choice',
        defaults: {
            choiceMode: 'checkbox'
        }
    },
    'pie-constructed-response': {
        name: 'Constructed Resposne',
        piePackage: '@pie-element/extended-text-entry'
    }
};
export function getModel(tagName) {
    function guidGenerator() {
        // Creates simple ids - they only need to be unique within the current model.
        var S4 = function () {
            // http://guid.us/GUID/JavaScript
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        };
        return `p-${S4() + S4()}`;
    }
    const pieDefinition = availablePies[tagName];
    if (!pieDefinition)
        return;
    const id = guidGenerator();
    return {
        id,
        elements: { [tagName]: pieDefinition.piePackage + '@latest' },
        models: [Object.assign({ id, element: tagName }, pieDefinition.defaults)],
        markup: `<${tagName} id='${id}'></${tagName}>`
    };
}
