import { h } from "@stencil/core";
export class EnterToken {
    onChange(e) {
        this.value = e.target.value;
        console.log(this.value);
    }
    onKeyDown(ev) {
        if (ev.key === "Enter") {
            this.submit();
        }
    }
    submit() {
        if (this.value && this.value.length > 0) {
            this.token.emit(this.value);
        }
    }
    componentDidLoad() {
        setTimeout(() => {
            this.textarea.focus();
        }, 100);
    }
    render() {
        return (h("div", null,
            h("h5", null, "Enter your token"),
            h("textarea", { class: "ta", ref: (r) => (this.textarea = r), value: this.value, onInput: (e) => this.onChange(e), onKeyDown: (e) => this.onKeyDown(e) }),
            h("br", null),
            h("br", null),
            h("input", { type: "submit", onClick: () => this.submit() }, "GO")));
    }
    static get is() { return "enter-token"; }
    static get originalStyleUrls() { return {
        "$": ["enter-token.css"]
    }; }
    static get styleUrls() { return {
        "$": ["enter-token.css"]
    }; }
    static get properties() { return {
        "value": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "value",
            "reflect": false
        }
    }; }
    static get events() { return [{
            "method": "token",
            "name": "token",
            "bubbles": true,
            "cancelable": true,
            "composed": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            }
        }]; }
}
