import { h } from "@stencil/core";
export class TokenHelper {
    receiveToken(e) {
        this.token = e.detail;
    }
    connectedCallback() {
        console.log("connected..");
        const p = new URLSearchParams(document.location.search);
        if (p.has("token")) {
            this.token = p.get("token");
        }
    }
    componentDidUpdate() {
        console.log("componentDidUpdate..");
        this.applyToken();
    }
    componentDidLoad() {
        console.log("componentDidLoad..");
        this.applyToken();
    }
    applyToken() {
        if (!this.token) {
            return;
        }
        const params = new URLSearchParams(document.location.search);
        if (!params.has("token")) {
            params.append("token", this.token);
            const u = `${document.location.href}?${params.toString()}`;
            window.history.replaceState({}, document.title, u);
        }
        const a = this.el.querySelectorAll("pie-api-author");
        if (a.length > 0) {
            a.forEach((el) => {
                el.token = this.token;
                // el.load();
            });
        }
        const p = this.el.querySelectorAll("pie-api-player");
        if (p.length > 0) {
            p.forEach((el) => {
                console.log("el:", el);
                el.token = this.token;
                console.log("el:", el);
            });
        }
    }
    render() {
        return this.token ? (h("slot", null)) : (h("enter-token", { onToken: (e) => this.receiveToken(e) }));
    }
    static get is() { return "token-helper"; }
    static get encapsulation() { return "shadow"; }
    static get states() { return {
        "token": {}
    }; }
    static get elementRef() { return "el"; }
}
