
 const availablePies = {
  'pie-multiple-choice': {
    name: 'Multiple Choice',
    piePackage: '@pie-element/multiple-choice',
    defaults: {
      choiceMode: 'radio',
      choicePrefix: 'numbers',
      itemStem: "choose one",
      choices: [
        {
          value: 'sweden',
          label: 'Sweden',
        },
        {
          value: 'iceland',
          label: 'Iceland',
        },
      ]
    },
    configSettings: {
      "addChoiceButton": {
        "settings": true,
        "label": "Add"
      },
      "choiceMode": {
        "settings": true,
        "label": "Response Type"
      },
      "choicePrefix": {
        "settings": true,
        "label": "Choice Labels~"
      },
      "deleteChoice": {
        "settings": true
      },
      "feedback": {
        "settings": false
      },
      "itemStem": {
        "settings": true,
        "label": "Item Stemmm"
      },
      "lockChoiceOrder": {
        "settings": true,
        "label": "Lock Choice Order"
      },
      "partialScoring": {
        "settings": true,
        "label": "Allow Partial Scoring!"
      },
      "rationale": {
        "settings": false,
        "label": "Rationale",
        "enabled": true
      },

    }
  },
  'pie-multiple-select': {
    name: 'Multiple Select',
    piePackage: '@pie-element/multiple-choice',
    defaults: {
      choiceMode: 'checkbox',
      choicePrefix: 'numbers',
      itemStem: "choose some",
      choices: [
        {
          value: 'sweden',
          label: 'Sweden',
        },
        {
          value: 'iceland',
          label: 'Iceland',
        },
      ]
    }
  },
  'pie-constructed-response': {
    name: 'Constructed Resposne',
    piePackage: '@pie-element/extended-text-entry'
  },
  'pie-ebsr': {
    name: 'EBSR',
    piePackage: '@pie-element/ebsr',
    defaults: {
      "partA": {
        "choices": [
          {
            "value": "yellow",
            "label": "<div>Yellow</div>",
            "correct": false
          },
          {
            "value": "green",
            "label": "<div>Green</div>",
            "correct": false
          },
          {
            "correct": true,
            "value": "blue",
            "label": "<div>Blue</div>"
          }
        ],
        "choiceMode": "radio",
        "choicePrefix": "numbers",
        "itemStem": "Question Prompt goes here",
        "lockChoiceOrder": true,
        "partialScoring": false,
        "scoringType": "auto",
        "configure": {
          "answerChoiceCount": 4,
          "addChoiceButton": {
            "settings": true,
            "label": "Add a Choice"
          },
          "choiceMode": {
            "settings": true,
            "label": "Response Type"
          },
          "choicePrefix": {
            "settings": true,
            "label": "Choice Labelsss"
          },
          "deleteChoice": {
            "settings": true
          },
          "feedback": {
            "settings": true
          },
          "itemStem": {
            "settings": true,
            "label": "Prompt"
          },
          "lockChoiceOrder": {
            "settings": true,
            "label": "Lock Choice Order"
          },
          "partialScoring": {
            "settings": true,
            "label": "Allow Partial Scoring"
          },
          "rationale": {
            "settings": false,
            "label": "Rationale",
            "enabled": true
          },
          "scoringType": {
            "settings": false,
            "label": "Scoring Type"
          },
          "studentInstructions": {
            "settings": false,
            "label": "Student Instructions",
            "enabled": true
          },
          "teacherInstructions": {
            "settings": false,
            "label": "Teacher Instructions",
            "enabled": true
          }
        },
        "keyMode": "numbers",
        "partialScoringLabel": "Each correct response that is correctly checked and each incorrect response\n          that is correctly unchecked will be worth 1 point.\n          The maximum points is the total number of answer choices.",
        "prompt": "What color is the sky?",
        "shuffle": false,
        "showCorrect": false
      },
      "partB": {
        "choices": [
          {
            "value": "orange",
            "label": "<div>Orange</div>",
            "correct": false
          },
          {
            "correct": true,
            "value": "purple",
            "label": "<div>Purple</div>"
          },
          {
            "value": "pink",
            "label": "<div>Pink</div>"
          },
          {
            "value": "green",
            "label": "<div>Green</div>"
          }
        ],
        "choiceMode": "radio",
        "choicePrefix": "numbers",
        "itemStem": "Question Prompt goes here",
        "lockChoiceOrder": true,
        "partialScoring": false,
        "scoringType": "auto",
        "keyMode": "numbers",
        "partialScoringLabel": "Each correct response that is correctly checked and each incorrect response\n          that is correctly unchecked will be worth 1 point.\n          The maximum points is the total number of answer choices.",
        "prompt": "What color do you get when you mix Red with your answer in Part 1?",
        "shuffle": false
    }
  },
  configSettings: {
    "answerChoiceCount": 4,
    "addChoiceButton": {
      "settings": true,
      "label": "Add a Choice"
    },
    "choiceMode": {
      "settings": true,
      "label": "Response Type"
    },
    "choicePrefix": {
      "settings": true,
      "label": "Choice Labels"
    },
    "deleteChoice": {
      "settings": true
    },
    "feedback": {
      "settings": true
    },
    "itemStem": {
      "settings": true,
      "label": "Prompt"
    },
    "lockChoiceOrder": {
      "settings": true,
      "label": "Lock Choice Order"
    },
    "partialScoring": {
      "settings": true,
      "label": "Allow Partial Scoring"
    },
    "rationale": {
      "settings": false,
      "label": "Rationale",
      "enabled": true
    },
    "scoringType": {
      "settings": false,
      "label": "Scoring Type"
    },
    "studentInstructions": {
      "settings": false,
      "label": "Student Instructions",
      "enabled": true
    },
    "teacherInstructions": {
      "settings": false,
      "label": "Teacher Instructions",
      "enabled": true
    }
  }
  },
  "pie-math-inline": {
    name: "Equation Response",
    piePackage: '@pie-element/math-inline',
    defaults: {
      "responseType": "Advanced Multi",
      "expression": "y=",
      "question": "What is the equation for a slope?",
      "equationEditor": "everything",
      "response": {
        "id": "answerBlock1",
        "answer": "mx + b",
        "validation": "symbolic",
        "alternates": {},
        "allowSpaces": true,
        "allowDecimals": true
      },
      "responses": [],
      "partialScoring": true,
      "feedback": {
        "correct": {
          "type": "none",
          "default": "Correct"
        },
        "partial": {
          "type": "none",
          "default": "Nearly"
        },
        "incorrect": {
          "type": "none",
          "default": "Incorrect"
        }
      },
      "scoringType": "auto",
      "id": "0",
      "element": "pie-element-math-inline",
      "mode": "advanced"
    },
    configSettings: {
      "responseType": {
        "settings": true,
        "label": "Response type"
      },
      "rationale": {
        "settings": false,
        "label": "Rationale",
        "enabled": true
      },
      "scoringType": {
        "settings": false,
        "label": "Scoring Type"
      },
      "studentInstructions": {
        "settings": false,
        "label": "Student Instructions",
        "enabled": true
      },
      "teacherInstructions": {
        "settings": false,
        "label": "Teacher Instructions",
        "enabled": true
      },
      "partialScoring": {
        "settings": true,
        "label": "Allow Partial Scoring"
      }
    }
  }
};


function getModel(tagName) {

  function guidGenerator() {
    // Creates simple ids - they only need to be unique within the current model.
    var S4 = function() {
      // http://guid.us/GUID/JavaScript
      return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return `p-${S4() + S4()}`;
  }


  const pieDefinition = availablePies[tagName];
  if (!pieDefinition) return;
  const version = pieDefinition.piePackage.split('@')[2];// assumes @pie-element in package
  const id = guidGenerator();
  return {
    id,
    elements: { [tagName]: version ? pieDefinition.piePackage : pieDefinition.piePackage + '@latest' },
    models: [{ id, element:tagName, ...pieDefinition.defaults }],
    markup: `<${tagName} id="${id}"></${tagName}>`
  };
}


function getConfigSettings(tagName) {
  return availablePies[tagName] ? availablePies[tagName].configSettings : {};
}