const availablePies = {
  'pie-multiple-choice': {
    name: 'Multiple Choice',
    piePackage: '@pie-element/multiple-choice',
    defaults: {
      choiceMode: 'radio'
    }
  },
  'pie-multiple-select': {
    name: 'Multiple Select',
    piePackage: '@pie-element/multiple-choice',
    defaults: {
      choiceMode: 'checkbox'
    }
  },
  'pie-constructed-response': {
    name: 'Constructed Resposne',
    piePackage: '@pie-element/extended-text-entry'
  }
};

function getModel(tagName) {
  function guidGenerator() {
    // Creates simple ids - they only need to be unique within the current model.
    var S4 = function() {
      // http://guid.us/GUID/JavaScript
      return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return `p-${S4() + S4()}`;
  }
  const pieDefinition = availablePies[tagName];
  if (!pieDefinition) return;
  const id = guidGenerator();
  return {
    id,
    elements: { [tagName]: pieDefinition.piePackage + '@latest' },
    models: [{ id, ...pieDefinition.defaults }],
    markup: `<${tagName} id="${id}"></${tagName}>`
  };
}

// 
const author = document.getElementById('author');
// const author = document.createElement('pie-api-author');
// author.setAttribute('content-id', "E1089");
author.setAttribute('host', 'https://develop.pie-api.io');
author.setAttribute('token', "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhY2kiOiI4MzNmM2MwYi1jNDFmLTQzMDQtOTNiMi1kMDlmZWFmYWY3MjYiLCJqdGkiOiI0NThmNjNkMC00NWQwLTExZTktYTVlZi1jN2Q2ODVmOGY4NTAiLCJpYXQiOjE1NTI1MDk2NDMsImV4cCI6MTY2MjU5NjA0Mywic2NvcGVzIjpbXX0.HlZFTjJD-xh4MHng55dtY8_tBjRD7RLnUVlkaTa4yJE");

// console.log('setting config ...');
// author.componentOnReady();
const model = getModel('pie-multiple-choice');
author.contentConfig = model;
// author.componentOnReady().then(() => {
//   console.log('componentOnReady setting config ...');
  
// });

// body.appendChild(author);

function changePie(pieName) {
  author.contentConfig = getModel(pieName);
}

const body = document.querySelector('body');

Object.keys(availablePies).forEach(key => {
  // console.log(`key = ${key}`)
  const button = document.createElement('button');
  button.id = key;
  button.label = key;
  button.textContent = key;
  button.onclick = () => author.contentConfig = getModel(key);;
  document.getElementById("changePies").appendChild(button);
});
