var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, h, c as createEvent, g as getContext, d as getElement } from './core-80804c5e.js';
import { N as NewRelicEnabledClient, F as FetchUtils, M as Mode, R as Role, H as HOST_DEFAULTS, P as PLAYER_HOST_CONFIG, V as VERSION, l as loadFromPieApi, s as splitStimulusItemsBundle, a as NewRelicInstrumentationService } from './graphql-f5d6a437.js';
import { r as root, i as isObject, a as addRubric } from './rubric-utils-61de23c8.js';
import { c as createCommonjsModule, u as unwrapExports, n as normalizeContentElements } from './utils-e506e807.js';
import { t as toNumber, V as VERSION$1, P as PieLoader, B as BundleType, m as mathRenderingAccessible$1, D as DEFAULT_ENDPOINTS } from './version-7a3b9487.js';
var ErrorMessage = /** @class */ (function () {
    function ErrorMessage(hostRef) {
        registerInstance(this, hostRef);
    }
    ErrorMessage.prototype.render = function () {
        return (h("div", { class: "errorContainer" }, h("div", { class: "errorIcon" }, h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 25 25", fill: "none", stroke: "currentColor", "stroke-width": "2", "stroke-linecap": "round", "stroke-linejoin": "round", class: "errorSvg" }, h("path", { d: "M10.29 3.86L1.82 18a2 2 0 0 0 1.71 3h16.94a2 2 0 0 0 1.71-3L13.71 3.86a2 2 0 0 0-3.42 0z" }), h("line", { x1: "12", y1: "9", x2: "12", y2: "13" }), h("line", { x1: "12", y1: "17", x2: "12", y2: "17" }))), h("div", { class: "errorMessage" }, this.message)));
    };
    Object.defineProperty(ErrorMessage, "style", {
        get: function () { return ".errorSvg{height:250px;width:250px;stroke:#d3d3d3}.errorMessage{font-family:sans-serif}.errorContainer{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex-align:center;align-items:center}"; },
        enumerable: true,
        configurable: true
    });
    return ErrorMessage;
}());
var isMethodAndPath = function (m) { return m && m.path && m.method; };
var toMethodAndPath = function (m) {
    if (isMethodAndPath(m)) {
        return m;
    }
    if (typeof m === "string") {
        return { method: "POST", path: m };
    }
    throw new Error("Unknown type " + m);
};
var PlayerApiClient = /** @class */ (function (_super) {
    __extends(PlayerApiClient, _super);
    function PlayerApiClient(token, endpoints, optimize, retryConfig) {
        var _this = _super.call(this) || this;
        _this.token = token;
        _this.endpoints = endpoints;
        _this.optimize = optimize;
        // Create a FetchUtils instance with tracking info
        _this.fetchUtils = new FetchUtils({
            host: _this.endpoints.host,
            optimize: _this.optimize,
            hasToken: !!_this.token
        }, retryConfig);
        return _this;
    }
    /**
     * Implementation of the abstract method from NewRelicEnabledClient
     */
    PlayerApiClient.prototype.getTrackingBaseAttributes = function () {
        return {
            host: this.endpoints.host,
            optimize: this.optimize,
            hasToken: !!this.token,
            networkInfo: this.getNetworkInfo()
        };
    };
    /**
     * Make an API call with retry mechanism
     *
     * @param endpoint - The API endpoint to call (method and path)
     * @param data - The data to send in the request body (will be JSON stringified)
     * @returns A promise that resolves to the parsed response data
     * @throws Error if all retry attempts fail
     */
    PlayerApiClient.prototype.call = function (endpoint, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                return [2 /*return*/, this.fetchUtils.callApi("" + this.endpoints.host + endpoint.path, endpoint.method, this.token, data)];
            });
        });
    };
    PlayerApiClient.prototype.load = function (itemId, sessionId, env, assignmentId, overrides) {
        var params = {
            itemId: itemId,
            sessionId: sessionId,
            assignmentId: assignmentId,
            env: env
        };
        if (overrides) {
            params.overrides = overrides;
        }
        return this.call(toMethodAndPath(this.endpoints.load), params);
    };
    PlayerApiClient.prototype.saveSession = function (session, env) {
        return this.call(toMethodAndPath(this.endpoints.saveSession), {
            data: session.data,
            sessionId: session.id,
            env: env
        });
    };
    PlayerApiClient.prototype.model = function (session, env, overrides) {
        var params = {
            sessionId: session.id,
            data: session.data,
            env: env
        };
        if (overrides) {
            params.overrides = overrides;
        }
        return this.call(toMethodAndPath(this.endpoints.model), params);
    };
    PlayerApiClient.prototype.score = function (session, env, overrides) {
        var params = {
            sessionId: session.id,
            data: session.data,
            env: env,
            overrides: overrides
        };
        if (overrides) {
            params.overrides = overrides;
        }
        return this.call(toMethodAndPath(this.endpoints.score), params);
    };
    return PlayerApiClient;
}(NewRelicEnabledClient));
/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function () {
    return root.Date.now();
};
var now_1 = now;
/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';
/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max, nativeMin = Math.min;
/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
    var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
    if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
    }
    wait = toNumber(wait) || 0;
    if (isObject(options)) {
        leading = !!options.leading;
        maxing = 'maxWait' in options;
        maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
        trailing = 'trailing' in options ? !!options.trailing : trailing;
    }
    function invokeFunc(time) {
        var args = lastArgs, thisArg = lastThis;
        lastArgs = lastThis = undefined;
        lastInvokeTime = time;
        result = func.apply(thisArg, args);
        return result;
    }
    function leadingEdge(time) {
        // Reset any `maxWait` timer.
        lastInvokeTime = time;
        // Start the timer for the trailing edge.
        timerId = setTimeout(timerExpired, wait);
        // Invoke the leading edge.
        return leading ? invokeFunc(time) : result;
    }
    function remainingWait(time) {
        var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
        return maxing
            ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)
            : timeWaiting;
    }
    function shouldInvoke(time) {
        var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
        // Either this is the first call, activity has stopped and we're at the
        // trailing edge, the system time has gone backwards and we're treating
        // it as the trailing edge, or we've hit the `maxWait` limit.
        return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
            (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
    }
    function timerExpired() {
        var time = now_1();
        if (shouldInvoke(time)) {
            return trailingEdge(time);
        }
        // Restart the timer.
        timerId = setTimeout(timerExpired, remainingWait(time));
    }
    function trailingEdge(time) {
        timerId = undefined;
        // Only invoke if we have `lastArgs` which means `func` has been
        // debounced at least once.
        if (trailing && lastArgs) {
            return invokeFunc(time);
        }
        lastArgs = lastThis = undefined;
        return result;
    }
    function cancel() {
        if (timerId !== undefined) {
            clearTimeout(timerId);
        }
        lastInvokeTime = 0;
        lastArgs = lastCallTime = lastThis = timerId = undefined;
    }
    function flush() {
        return timerId === undefined ? result : trailingEdge(now_1());
    }
    function debounced() {
        var time = now_1(), isInvoking = shouldInvoke(time);
        lastArgs = arguments;
        lastThis = this;
        lastCallTime = time;
        if (isInvoking) {
            if (timerId === undefined) {
                return leadingEdge(lastCallTime);
            }
            if (maxing) {
                // Handle invocations in a tight loop.
                clearTimeout(timerId);
                timerId = setTimeout(timerExpired, wait);
                return invokeFunc(lastCallTime);
            }
        }
        if (timerId === undefined) {
            timerId = setTimeout(timerExpired, wait);
        }
        return result;
    }
    debounced.cancel = cancel;
    debounced.flush = flush;
    return debounced;
}
var debounce_1 = debounce;
var PieApiPlayer = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.initialized = false;
        /**
         * Use the beta controllers for pie-elements
         */
        this.optimize = false;
        /**
         * Enable screen recording with New Relic.
         * Note: not to be used in production unless for temporary use to track down a specific user problem.
         * Defaults to false
         */
        this.recordScreen = false;
        /**
         * Enable exception tracking with New Relic.
         */
        this.exceptions = false;
        /**
         * Enable tracking page actions/events with New Relic.
         * Note: Setting this to true increases data sent to New Relic, which may affect costs.
         */
        this.trackPageActions = false;
        /**
         * In evaluate mode, add a bottom border to visually separate each item in the case of a multi-item
         */
        this.showBottomBorder = false;
        /**
         * The mode to be used when player is initialized
         */
        this.initialMode = Mode.gather;
        /**
         * The role to be used when player is initialized
         */
        this.initialRole = Role.student;
        /**
         * If the item contains a passage, the player will render it by default.
         * Set this property to false to not render passage.
         */
        this.renderStimulus = true;
        /**
         * It will allow to resize passage and item width for items with stimulus
         */
        this.allowedResize = false;
        /**
         * Choose 'dev' , 'stage' or 'prod' environments for back end.
         */
        this.host = 'prod';
        /**
         * used to automatically re-fetch the bundle (in case we get a 503); defaults to false
         */
        this.reFetchBundle = false;
        /**
         * Customize markup.
         */
        this.customMarkup = '';
        /**
         * If this property is set the item will be rendered in a `preview` state by the player.
         * This means no server-side calls will be made and no reponse-session will be created/stored in pie-api.
         */
        this.preview = false;
        this.recordingStarted = createEvent(this, "recordingStarted", 7);
        this.saveSessionError = createEvent(this, "saveSessionError", 7);
        this.sessionSaved = createEvent(this, "sessionSaved", 7);
        this.modelReload = createEvent(this, "model-reload", 7);
        this.playerError = createEvent(this, "api-player-error", 7);
        this.sessionCreated = createEvent(this, "session-created", 7);
        this.doc = getContext(this, "document");
    }
    class_1.prototype.watchHostEnvironment = function (newVal) {
        if (newVal) {
            this._apiConfig = this._apiConfig || {};
            this._apiConfig.host = HOST_DEFAULTS[newVal].apiUrl;
            this._apiConfig.bundleBaseUrl = HOST_DEFAULTS[newVal].bundleBaseUrl;
        }
    };
    class_1.prototype.onCustomConfigChange = function (newValue) {
        console.log('customConfig now', newValue);
    };
    class_1.prototype.onCustomModelsChange = function (newValue) {
        console.log('customModels now', newValue);
    };
    class_1.prototype.onCustomPassageModelsChange = function (newValue) {
        console.log('customPassageModels now', newValue);
    };
    class_1.prototype.onCustomMarkupChange = function (newValue) {
        console.log('customMarkup now', newValue);
    };
    Object.defineProperty(class_1.prototype, "safeConfig", {
        get: function () {
            return Object.assign(Object.assign(Object.assign({}, PLAYER_HOST_CONFIG), this._apiConfig), this.customConfig);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Get the retry configuration from component properties
     */
    class_1.prototype.getRetryConfig = function () {
        var config = {};
        if (this.maxRetryAttempts !== undefined)
            config.maxRetryAttempts = this.maxRetryAttempts;
        if (this.requestTimeoutMs !== undefined)
            config.requestTimeoutMs = this.requestTimeoutMs;
        if (this.initialRetryDelayMs !== undefined)
            config.initialRetryDelayMs = this.initialRetryDelayMs;
        if (this.maxRetryDelayMs !== undefined)
            config.maxRetryDelayMs = this.maxRetryDelayMs;
        if (this.trackPageActions !== undefined)
            config.trackPageActions = this.trackPageActions;
        return Object.keys(config).length > 0 ? config : undefined;
    };
    class_1.prototype.initPlayerClient = function () {
        if (this.token) {
            this.playerClient = new PlayerApiClient(this.token, this.safeConfig, this.optimize, this.getRetryConfig());
        }
    };
    class_1.prototype.watchToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        _s.trys.push([0, 2, , 3]);
                        this.initPlayerClient();
                        return [4 /*yield*/, this.load()];
                    case 1:
                        _s.sent();
                        /**
                         * Have to call this cos playerInfo is not part of the component state?
                         */
                        this.el.forceUpdate();
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _s.sent();
                        this.trackError('Error during token update', err_1, {
                            errorContext: 'watchToken',
                            hasPlayerClient: !!this.playerClient
                        });
                        this.playerError.emit({
                            message: 'Error during token update',
                            details: err_1.message || err_1,
                        });
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.watchItemId = function (newValue, oldValue) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                if (newValue !== oldValue) {
                    this.updateItemOrSession();
                }
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.watchRetryConfig = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                // Reinitialize the player client with the new retry configuration
                if (this.token) {
                    this.initPlayerClient();
                }
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.watchEnv = function (newEnv) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, updatedEnv, allModels, player, models_1, passageModels_1, findModel_1, updatedModels, updatedPassageModels, config, e_1;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        updatedEnv = Object.assign(Object.assign({}, (this.player && this.player.env
                            ? this.player.env
                            : {})), newEnv);
                        if (!(this.playerInfo && this.player)) return [3 /*break*/, 5];
                        _s.label = 1;
                    case 1:
                        _s.trys.push([1, 4, , 5]);
                        if (!!this.preview) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.playerClient.model(this.player.session, updatedEnv, this.getOverrides())];
                    case 2:
                        allModels = _s.sent();
                        player = this.player;
                        models_1 = ((_b = (_a = player) === null || _a === void 0 ? void 0 : _a.config) === null || _b === void 0 ? void 0 : _b.models) || ((_e = (_d = (_c = player) === null || _c === void 0 ? void 0 : _c.config) === null || _d === void 0 ? void 0 : _d.pie) === null || _e === void 0 ? void 0 : _e.models) || [];
                        passageModels_1 = ((_h = (_g = (_f = player) === null || _f === void 0 ? void 0 : _f.config) === null || _g === void 0 ? void 0 : _g.passage) === null || _h === void 0 ? void 0 : _h.models) || [];
                        findModel_1 = function (models, model) { var _a; return (_a = models) === null || _a === void 0 ? void 0 : _a.find(function (m) { return m.id === model.id && m.element === model.element; }); };
                        updatedModels = allModels.filter(function (model) { return findModel_1(models_1, model); });
                        updatedPassageModels = allModels.filter(function (model) { return findModel_1(passageModels_1, model); });
                        config = this.getConfigParsed(player.config, updatedModels, updatedPassageModels);
                        player.config = config;
                        _s.label = 3;
                    case 3:
                        this.player.env = updatedEnv;
                        return [2 /*return*/, { error: null }];
                    case 4:
                        e_1 = _s.sent();
                        this.trackError('Environment update error', e_1, {
                            errorContext: 'watchEnv',
                            originalEnv: JSON.stringify(this.env || {}),
                            newEnv: JSON.stringify(newEnv || {}),
                            updatedEnv: JSON.stringify(updatedEnv || {}),
                            hasPlayerInfo: !!this.playerInfo,
                            hasPlayerConfig: !!((_j = this.player) === null || _j === void 0 ? void 0 : _j.config),
                            modelCount: ((_m = (_l = (_k = this.player) === null || _k === void 0 ? void 0 : _k.config) === null || _l === void 0 ? void 0 : _l.models) === null || _m === void 0 ? void 0 : _m.length) || ((_r = (_q = (_p = (_o = this.player) === null || _o === void 0 ? void 0 : _o.config) === null || _p === void 0 ? void 0 : _p.pie) === null || _q === void 0 ? void 0 : _q.models) === null || _r === void 0 ? void 0 : _r.length) || 0
                        });
                        this.playerError.emit({
                            message: 'Error updating environment',
                            details: e_1.message || e_1,
                        });
                        return [2 /*return*/, { error: e_1.message }];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.watchRecordScreen = function (newVal, oldVal) {
        if (newVal && newVal !== oldVal) {
            if (this.newRelic && this.recordScreenIdentity) {
                // Set user identity for New Relic session
                this.newRelic.setUserId(this.recordScreenIdentity);
                // Record session start
                if (this.trackPageActions) {
                    this.newRelic.addPageAction('session_recording_started', {
                        appVersion: VERSION,
                        itemId: this.itemId,
                        sessionId: this.sessionId
                    });
                }
                this.recordingStarted.emit('Session recording started with New Relic');
            }
        }
    };
    /**
     * Return the evaluated score for the current response.
     * The api token must provide permission to authorize the use of this method.
     *
     * Note: Score does not (yet) work when in preview mode - will resolve to null if `preview` is `true`
     *
     * @param disablePartialScoring - if true all interactions will be scored as either correct or incorrect
     */
    class_1.prototype.score = function (disablePartialScoring) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                if (disablePartialScoring === true || disablePartialScoring === false) {
                    console.warn('disablePartialScoring is no longer used - set env instead: {partialScoring: true|false, ...}');
                }
                if (this.preview) {
                    return [2 /*return*/, Promise.resolve(null)];
                }
                else {
                    return [2 /*return*/, this.playerClient.score(this.playerInfo.session, this.env, this.getOverrides())];
                }
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.saveSession = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, error_1;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        if (!(this.player && this.player.session && !this.preview)) return [3 /*break*/, 4];
                        _s.label = 1;
                    case 1:
                        _s.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.playerClient.saveSession(this.player.session, this.env || {})];
                    case 2:
                        _s.sent();
                        // Track successful session save in New Relic
                        if (this.newRelic && this.trackPageActions) {
                            this.newRelic.addPageAction('session_saved', {
                                sessionId: this.sessionId
                            });
                        }
                        this.sessionSaved.emit(this.sessionId);
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _s.sent();
                        console.warn('could not save session');
                        this.saveSessionError.emit(error_1);
                        this.trackError('Error saving session', error_1, {
                            errorContext: 'session-changed event',
                            envMode: ((_a = this.env) === null || _a === void 0 ? void 0 : _a.mode) || this.initialMode,
                            envRole: ((_b = this.env) === null || _b === void 0 ? void 0 : _b.role) || this.initialRole,
                            sessionData: JSON.stringify(((_c = this.player.session) === null || _c === void 0 ? void 0 : _c.data) || []),
                            hasSessionId: !!this.sessionId,
                            sessionPath: ((_d = this.player.session) === null || _d === void 0 ? void 0 : _d.id) ? 'session.id exists' : 'no session.id'
                        });
                        this.playerError.emit({
                            message: 'Error saving session',
                            details: error_1.message || error_1,
                        });
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Listens for session changed events and saves updated data for session
     */
    class_1.prototype.handleSessionChange = function () {
        this.debouncedSaveSession();
    };
    class_1.prototype.handlePlayerError = function (ev) {
        this.playerInfo = null;
        this.errorMessage = ev.detail;
        // Collect as much context as possible for player errors
        var errorContext = {
            errorContext: 'player-error event',
            errorPayload: typeof ev.detail === 'object' ? JSON.stringify(ev.detail) : String(ev.detail),
            playerState: this.player ? 'initialized' : 'not initialized',
            playerConfig: this.player && this.player.config ? 'has config' : 'no config',
            currentRoute: typeof window !== 'undefined' ? window.location.pathname : 'unknown'
        };
        this.trackError('Player error', ev.detail || new Error('Unknown player error'), errorContext);
    };
    /**
     * Helper method to track errors with New Relic
     * This is a utility method that centralizes our error reporting logic and ensures
     * we capture comprehensive error information including stack traces.
     */
    class_1.prototype.trackError = function (message, error, customAttributes) {
        if (customAttributes === void 0) { customAttributes = {}; }
        var _a, _b, _c;
        // First check if newRelic exists to avoid null reference
        if (!this.newRelic) {
            console.error("[pie-api-player] " + message + ":", error);
            return;
        }
        var shouldReportToNewRelic = this.newRelic && (_a = this.exceptions, (_a !== null && _a !== void 0 ? _a : false));
        if (shouldReportToNewRelic) {
            // Ensure we have an actual Error object with stack trace
            var errorObj = error instanceof Error ? error : new Error(typeof error === 'string' ? error : JSON.stringify(error));
            // Extract stack trace if available
            var stackTrace = errorObj.stack || '';
            // Add default attributes with comprehensive context
            var attributes = Object.assign(Object.assign({}, customAttributes), { itemId: this.itemId, sessionId: this.sessionId, message: message, appVersion: VERSION, errorMessage: errorObj.message || String(error), stackTrace: stackTrace, componentState: {
                    mode: ((_b = this.env) === null || _b === void 0 ? void 0 : _b.mode) || this.initialMode,
                    role: ((_c = this.env) === null || _c === void 0 ? void 0 : _c.role) || this.initialRole,
                    preview: this.preview
                }, time: new Date().toISOString() });
            // Use New Relic's noticeError API to report the error
            this.newRelic.noticeError(errorObj, attributes);
        }
        // Always log to console for debugging
        console.error("[pie-api-player] " + message + ":", error, customAttributes);
    };
    class_1.prototype.updateItemOrSession = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        _s.trys.push([0, 3, , 4]);
                        this.playerInfo = null;
                        if (!!this.preview) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.load()];
                    case 1:
                        _s.sent();
                        _s.label = 2;
                    case 2:
                        this.el.forceUpdate();
                        return [3 /*break*/, 4];
                    case 3:
                        err_2 = _s.sent();
                        this.trackError('Error updating item or session', err_2, {
                            errorContext: 'updateItemOrSession',
                            itemId: this.itemId,
                            sessionId: this.sessionId,
                            preview: this.preview,
                            updateTriggeredBy: 'property change'
                        });
                        this.playerError.emit({
                            message: 'Error updating item or session',
                            details: err_2.message || err_2,
                        });
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.readyToLoad = function () {
        return (this.itemId || this.sessionId) && this.playerClient && this.token;
    };
    class_1.prototype.getOverrides = function () {
        var overrides = undefined;
        try {
            if (typeof this.overrides === 'string') {
                overrides = JSON.parse(this.overrides);
            }
            else {
                if (this.overrides) {
                    overrides = this.overrides;
                }
            }
        }
        catch (e) {
        }
        return overrides;
    };
    class_1.prototype.load = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, buildPlayerConfig, contentData, info, _s, apiInfo, _t, bundle1, bundle2, err_3;
            return __generator(this, function (_u) {
                switch (_u.label) {
                    case 0:
                        _u.trys.push([0, 7, , 8]);
                        if (!this.preview) return [3 /*break*/, 4];
                        this.env
                            ? (this.env.role = Role.instructor)
                            : (this.env = { role: Role.instructor, mode: Mode.view });
                        buildPlayerConfig = function (response) {
                            var _a;
                            // TODO pie-api-aws 10. test this once passages are tested
                            var passage = (_a = response) === null || _a === void 0 ? void 0 : _a.passage;
                            var out = {
                                session: { id: '', data: [] },
                            };
                            if (passage) {
                                return Object.assign(Object.assign({}, out), { item: { pie: response.config, passage: passage.config } });
                            }
                            else {
                                return Object.assign(Object.assign({}, out), { item: response.config });
                            }
                        };
                        if (!(this.itemId && this.token)) return [3 /*break*/, 2];
                        return [4 /*yield*/, loadFromPieApi(this.token, this.itemId, this.safeConfig.host, this.getOverrides())];
                    case 1:
                        contentData = _u.sent();
                        info = buildPlayerConfig(contentData);
                        console.log(info);
                        console.log(this);
                        this.modelReload.emit(info);
                        this.playerInfo = info;
                        return [3 /*break*/, 3];
                    case 2:
                        this.errorMessage = 'no item id passed to player';
                        _u.label = 3;
                    case 3: return [3 /*break*/, 6];
                    case 4:
                        if (!(!this.playerInfo && this.readyToLoad())) return [3 /*break*/, 6];
                        // Track load start in New Relic
                        if (this.newRelic && this.trackPageActions) {
                            this.newRelic.addPageAction('item_load_started', {
                                itemId: this.itemId,
                                sessionId: this.sessionId
                            });
                        }
                        _s = this;
                        return [4 /*yield*/, this.playerClient.load(this.itemId, this.sessionId, Object.assign(Object.assign({}, this.env), { mode: this.env && this.env.mode ? this.env.mode : this.initialMode, role: this.env && this.env.role ? this.env.role : this.initialRole }), this.assignmentId, this.getOverrides())];
                    case 5:
                        _s.playerInfo = _u.sent();
                        // Track successful load in New Relic
                        if (this.newRelic && this.trackPageActions) {
                            this.newRelic.addPageAction('item_loaded', {
                                itemId: this.itemId,
                                sessionId: (_a = this.playerInfo.session) === null || _a === void 0 ? void 0 : _a.id
                            });
                        }
                        apiInfo = this.playerInfo.item;
                        // is passage model
                        if (apiInfo && apiInfo.pie) {
                            if (this.playerInfo.js && this.playerInfo.js.view) {
                                _t = splitStimulusItemsBundle(this.playerInfo.js.view), bundle1 = _t[0], bundle2 = _t[1];
                                apiInfo.pie.bundle = { url: bundle1 };
                                apiInfo.passage.bundle = { url: bundle2 };
                            }
                        }
                        else {
                            if (this.playerInfo.js && this.playerInfo.js.view) {
                                apiInfo.bundle = { url: this.playerInfo.js.view };
                            }
                        }
                        this.playerInfo.item = apiInfo;
                        if (!this.sessionId &&
                            this.playerInfo.session &&
                            this.playerInfo.session.id) {
                            this.sessionCreated.emit(this.playerInfo.session);
                        }
                        _u.label = 6;
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        err_3 = _u.sent();
                        this.errorMessage = 'error loading item';
                        console.error(err_3);
                        this.trackError('Error loading item', err_3, {
                            errorContext: 'load method',
                            itemId: this.itemId,
                            sessionId: this.sessionId,
                            isPreview: this.preview,
                            hasToken: !!this.token,
                            hasApiConfig: !!this._apiConfig,
                            apiHost: (_b = this.safeConfig) === null || _b === void 0 ? void 0 : _b.host,
                            loadState: this.playerInfo ? 'has playerInfo' : 'no playerInfo',
                            readyToLoad: this.readyToLoad(),
                            initialMode: this.initialMode,
                            initialRole: this.initialRole,
                            hasAssignmentId: !!this.assignmentId,
                            hasOverrides: !!this.getOverrides()
                        });
                        this.playerError.emit({
                            message: 'Error loading item',
                            details: err_3.message || err_3,
                        });
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.componentWillLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        this.debouncedSaveSession = debounce_1(this.saveSession.bind(this), 100);
                        this.newRelic = new NewRelicInstrumentationService(this.doc);
                        this.newRelic.setApplicationVersion("pie-api-components@" + VERSION);
                        this.newRelic.setCustomAttribute('componentType', 'pie-api-player');
                        if (this.newRelic && this.trackPageActions) {
                            this.newRelic.addPageAction('component_loaded', {
                                itemId: this.itemId,
                                sessionId: this.sessionId
                            });
                        }
                        if (this.recordScreen) {
                            this.watchRecordScreen(this.recordScreen, false);
                        }
                        this.watchHostEnvironment(this.host);
                        this.initPlayerClient();
                        if (!this.readyToLoad()) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.load()];
                    case 1:
                        _s.sent();
                        _s.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.disconnectedCallback = function () {
        // Record component unload if tracking is enabled
        if (this.newRelic && this.trackPageActions) {
            this.newRelic.addPageAction('component_unloaded', {
                itemId: this.itemId,
                sessionId: this.sessionId
            });
        }
    };
    class_1.prototype.overrideModels = function (models, customModels) {
        var _a;
        if (!((_a = customModels) === null || _a === void 0 ? void 0 : _a.length)) {
            return models || [];
        }
        return (models || []).map(function (model) { return (Object.assign(Object.assign({}, model), (customModels.find(function (cm) { return cm.id === model.id; }) || {}))); });
    };
    class_1.prototype.getConfigParsed = function (item, models, passageModels) {
        var _a, _b;
        // Check if 'item' has the 'pie' structure
        if (item && item.pie) {
            // Structure with 'pie'
            return Object.assign(Object.assign(Object.assign({}, item), { pie: Object.assign(Object.assign({}, item.pie), { models: this.overrideModels(models || item.pie.models, this.customModels), markup: this.customMarkup || item.pie.markup }) }), (item.passage
                ? {
                    passage: Object.assign(Object.assign({}, item.passage), { models: this.overrideModels(passageModels || item.passage.models, this.customPassageModels) }),
                }
                : {}));
        }
        // Standard structure
        return Object.assign(Object.assign({}, item), { models: this.overrideModels(models || ((_a = item) === null || _a === void 0 ? void 0 : _a.models), this.customModels), markup: this.customMarkup || ((_b = item) === null || _b === void 0 ? void 0 : _b.markup) });
    };
    class_1.prototype.render = function () {
        var _this = this;
        var item = (this.playerInfo || {}).item;
        var configParsed = this.getConfigParsed(item);
        if (this.playerInfo && this.playerInfo.item) {
            return (h("pie-player", { class: ("pie-api-player " + (this.customClassname || '')).trim(), hosted: !this.preview, bundleHost: this.host, addCorrectResponse: this.preview, config: configParsed, session: this.playerInfo.session, renderStimulus: this.renderStimulus, allowedResize: this.allowedResize, showBottomBorder: this.showBottomBorder, env: {
                    mode: this.env && this.env.mode ? this.env.mode : this.initialMode,
                    role: this.env && this.env.role ? this.env.role : this.initialRole,
                }, ref: function (el) { return (_this.player = el); }, bundleEndpoints: this.bundleEndpoints, reFetchBundle: this.reFetchBundle, externalStyleUrls: this.externalStyleUrls, customClassname: this.customClassname }, ' '));
        }
        else {
            if (this.errorMessage) {
                return h("error-message", { message: this.errorMessage });
            }
            else {
                return h("div", null, "not yet loaded");
            }
        }
    };
    Object.defineProperty(class_1.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "host": ["watchHostEnvironment"],
                "customConfig": ["onCustomConfigChange"],
                "customModels": ["onCustomModelsChange"],
                "customPassageModels": ["onCustomPassageModelsChange"],
                "customMarkup": ["onCustomMarkupChange"],
                "token": ["watchToken"],
                "sessionId": ["watchItemId"],
                "itemId": ["watchItemId"],
                "maxRetryAttempts": ["watchRetryConfig"],
                "requestTimeoutMs": ["watchRetryConfig"],
                "initialRetryDelayMs": ["watchRetryConfig"],
                "maxRetryDelayMs": ["watchRetryConfig"],
                "trackPageActions": ["watchRetryConfig"],
                "env": ["watchEnv"],
                "recordScreen": ["watchRecordScreen"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "style", {
        get: function () { return ".pie-api-player img{max-width:inherit;max-height:inherit}.book-title-k5{text-decoration:underline}.book-title{font-style:italic}.block-quote,.text-block{font-family:serif;margin-left:20%;margin-right:20%;margin-top:5px;margin-bottom:5px;width:60%;border:1px solid #000;padding:2px;display:block}.short-quote{font-weight:700}span.short-quote:before{content:open-quote}span.short-quote:after{content:close-quote}.word-callout{text-decoration:underline}.relative-emphasis{text-transform:uppercase}.content-emphasis{font-weight:700;color:red}span.passage-title:before{content:open-quote}span.passage-title:after{content:close-quote}.proper-name,.variable{font-style:italic}.equation-block{text-align:center;margin-left:20%;margin-right:20%;margin-top:5px;margin-bottom:5px;width:60%;padding:2px;display:block}.embedded-error{font-style:italic}div.passage-subtitle,div.passage-title{font-weight:700;text-align:center}div.passage-author{text-align:center}.p-number{float:left;font-size:.85em}.numbered-paragraph{margin-left:36px}\@media print{.kds-noprint,.noprint{display:none}}.abs,.kds-absolute{border-left:1px solid #000;border-right:1px solid #000;padding:0 .3em 0 .3em}.kds-border-1{border:1px solid #000}.kds-border-2{border:2px solid #000}.center,.kds-center{margin:0;text-align:center}.kds-exponent{font-size:85%}.kds-exponent,sup.frac{margin-left:-.4em;position:relative;top:-1.4em}sup.frac{font-size:70%}.kds-fillin{display:inline-block}.fillin,.kds-fillin{border:1px solid #000;margin:0 .2em;padding-left:1em}.fillin{display:inline-block;*display:inline}.kds-font-larger{font-size:larger}.kds-font-smaller{font-size:smaller}table.kds-fraction{border:0;display:inline-block;font-size:85%;margin:0;padding:0;vertical-align:middle}table.kds-fraction>tbody>tr>td.kds-numerator{border-bottom:1px solid #000;border-left:0;border-right:0;border-top:0;text-align:center}table.kds-fraction>tbody>tr>td.kds-denominator{border:0;text-align:center}table.frac{display:inline-block;*display:inline;vertical-align:middle;font-size:85%;border:0;margin:0;padding:0}.frac .nu{border-left:0;border-top:0;border-right:0;border-bottom:1px solid #000;text-align:center}.frac .de{border:0;text-align:center}.kds-hanging-indent{margin:0;padding-left:3em;text-indent:-3em}.kds-image-caption{font-family:Verdana,Arial,sans-serif;text-align:center}.kds-image-left{float:left;margin-right:5px}.kds-image-right{float:right;margin-left:5px}.indent,.kds-indent{text-indent:3em}.kds-nowrap{display:inline-block;white-space:nowrap}.kds-overline{text-decoration:overline}.kds-parentheses{font-family:Arial Narrow,Arial,sans-serif}.kds-parentheses,b.frac{font-size:300%;font-weight:400;position:relative;top:8px}b.frac{font-family:arial narrow}.kds-pi{font-family:Times New Roman,serif;font-size:1.2em}.newradical{border-collapse:collapse;display:inline-block;*display:inline;vertical-align:middle}.newradical td{border:0;padding:0;vertical-align:top}.newradical td.vinculum{border-top:1px solid #000;padding:0;vertical-align:top}.newradical div.exp{font-size:.7em;position:relative;left:7px;bottom:5px}.kds-underline,.under{text-decoration:underline}.kds-verdana2t,.Verdana2t{border:1px solid #fff;text-align:left;text-decoration:none;vertical-align:top}.kds-whole-number{display:inline-block}.kds-whole-number,.whole{font-size:120%;margin:0 0 0 .2em}.whole{display:inline-block;*display:inline}table.KdsTable01{border:1px solid #000;border-collapse:collapse;border-spacing:0}table.KdsTable01>tbody>tr>th{font-weight:400}table.KdsTable01>tbody>tr>th,table.KdsTable01>tbody>tr>th.bold{background-color:#d3d3d3;border:1px solid #000;padding:2px;text-align:center}table.KdsTable01>tbody>tr>th.bold{font-weight:700}table.KdsTable01>tbody>tr>td,table.KdsTable01>tbody>tr>td.bold{border:1px solid #000;padding:2px;text-align:center}table.KdsTable01>tbody>tr>td.bold{font-weight:700}table.KdsTable02{border:1px solid #000;border-collapse:collapse;border-spacing:0}table.KdsTable02>tbody>tr>th{background-color:#d3d3d3;font-weight:400}table.KdsTable02>tbody>tr>td,table.KdsTable02>tbody>tr>th{border:1px solid #000;padding:2px}.lrn_feature h3{margin-top:0!important}#item,#stimulus{width:50%;float:left}.table{width:100%;margin-bottom:1em;background-color:transparent}th{text-align:inherit}.table td,.table th{padding:.75em;vertical-align:top;border-top:1px solid #dee2e6}.table thead th{vertical-align:bottom;border-bottom:2px solid #dee2e6}.table-bordered,.table-bordered td,.table-bordered th{border:1px solid #dee2e6}.table-bordered thead td,.table-bordered thead th{border-bottom-width:2px}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
var lib = createCommonjsModule(function (module, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var ModelSetEvent = /** @class */ (function (_super) {
        __extends(ModelSetEvent, _super);
        function ModelSetEvent(component, complete, hasModel) {
            var _this = _super.call(this, ModelSetEvent.TYPE, { bubbles: true, composed: true, detail: { complete: complete, component: component, hasModel: hasModel } }) || this;
            _this.component = component;
            _this.complete = complete;
            return _this;
        }
        return ModelSetEvent;
    }(CustomEvent));
    ModelSetEvent.TYPE = 'model-set';
    exports.ModelSetEvent = ModelSetEvent;
    var SessionChangedEvent = /** @class */ (function (_super) {
        __extends(SessionChangedEvent, _super);
        function SessionChangedEvent(component, complete) {
            var _this = _super.call(this, SessionChangedEvent.TYPE, { bubbles: true, composed: true, detail: { complete: complete, component: component } }) || this;
            _this.component = component;
            _this.complete = complete;
            return _this;
        }
        return SessionChangedEvent;
    }(CustomEvent));
    SessionChangedEvent.TYPE = 'session-changed';
    exports.SessionChangedEvent = SessionChangedEvent;
});
unwrapExports(lib);
var lib_2 = lib.SessionChangedEvent;
var controllerErrorMessage = "Error processing question configuration, verify the question model?";
var Player = /** @class */ (function () {
    function class_2(hostRef) {
        registerInstance(this, hostRef);
        /**
         * Allows disabling of the default behaviour which is to look up and load the JS bundle that define the Custom Elements
         * used by the item config.
         * This if for advanced use cases when using the pie-player in a container that is managing loading of Custom Elements and Controllers.
         */
        this.disableBundler = false;
        this.elementsLoaded = false;
        /**
         * Simulates a correct response for the item.
         * This property will only have this effect if the `hosted` property is
         * false and player is running client-side-only.
         */
        this.addCorrectResponse = false;
        /**
         * In evaluate mode, add a bottom border to visually separate each item in the case of a multi-item
         */
        this.showBottomBorder = false;
        /**
         * used to automatically re-fetch the bundle (in case we get a 503)
         */
        this.reFetchBundle = false;
        /**
         * The Pie Session
         */
        this.session = { id: "", data: [] };
        /**
         * Describes runtime environment for the player.
         *
         */
        this.env = { mode: "gather", role: "student" };
        /**
         * Indicates if player running in the context of a PIE hosting system.
         * Do not modify the default value for this property if you are not implementing a PIE host.
         * If true, the host is responsible for all model updates.
         */
        this.hosted = false;
        /**
         * If the item contains a stimulus, the player will render it by default.
         * Set this property to false to not render stimulus.
         */
        this.renderStimulus = true;
        this.version = VERSION$1;
        /**
         * Allow to resize pie-stimulus layout
         * Set this property to false to not render the resizer.
         */
        this.allowedResize = false;
        this.pieLoader = new PieLoader(null, this.loaderConfig);
        this.sessionChanged = createEvent(this, "session-changed", 7);
        this.playerError = createEvent(this, "player-error", 7);
        this.responseCompleted = createEvent(this, "responseCompleted", 7);
        this.loadComplete = createEvent(this, "load-complete", 7);
        this.doc = getContext(this, "document");
    }
    class_2.prototype.watchAddCorrectResponse = function (newValue, oldValue) {
        if (newValue !== oldValue) {
            this.updateModels();
        }
    };
    class_2.prototype.player = function () {
        return this.stimulusPlayer ? this.stimulusPlayer : this;
    };
    class_2.prototype.watchConfig = function (newConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var endpoints, forceBundleUrl, err_4;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        this.elementsLoaded = false;
                        _s.label = 1;
                    case 1:
                        _s.trys.push([1, 4, , 5]);
                        if (!newConfig) {
                            return [2 /*return*/];
                        }
                        try {
                            if (typeof newConfig == "string") {
                                newConfig = JSON.parse(newConfig);
                            }
                            if (newConfig.pie) {
                                this.stimulusItemModel = newConfig;
                                return [2 /*return*/]; // if stimulus item
                            }
                            else if (newConfig.elements) {
                                this.pieContentModel = addRubric(newConfig);
                                this.pieContentModel = normalizeContentElements(this.pieContentModel);
                            }
                            else {
                                this.playerError.emit("invalid pie data model");
                                return [2 /*return*/];
                            }
                        }
                        catch (err) {
                            this.playerError.emit("exception processing content model - " + err.message);
                            return [2 /*return*/];
                        }
                        if (!(!this.elementsLoaded && !this.disableBundler)) return [3 /*break*/, 3];
                        endpoints = DEFAULT_ENDPOINTS.prod;
                        if (this.bundleHost &&
                            ["dev", "stage", "prod"].includes(this.bundleHost)) {
                            endpoints = DEFAULT_ENDPOINTS[this.bundleHost];
                        }
                        forceBundleUrl = false;
                        if (this.bundleEndpoints) {
                            endpoints = this.bundleEndpoints;
                            forceBundleUrl = true;
                        }
                        return [4 /*yield*/, this.pieLoader.loadCloudPies({
                                content: this.pieContentModel,
                                doc: this.doc,
                                endpoints: endpoints,
                                bundle: this.hosted ? BundleType.player : BundleType.clientPlayer,
                                useCdn: false,
                                forceBundleUrl: forceBundleUrl,
                                reFetchBundle: this.reFetchBundle
                            })];
                    case 2:
                        _s.sent();
                        _s.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        err_4 = _s.sent();
                        this.playerError.emit("problem loading item (" + err_4 + ")");
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * For previewing changes to an item. Updates the model for one question in the item model.
     * @param update the updated model
     */
    class_2.prototype.updateElementModel = function (update) {
        return __awaiter(this, void 0, void 0, function () {
            var index;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        if (!(this.pieContentModel && this.pieContentModel.models)) return [3 /*break*/, 2];
                        index = this.pieContentModel.models.findIndex(function (m) { return m.id === update.id; });
                        if (index !== -1) {
                            this.pieContentModel.models.splice(index, 1, update);
                        }
                        return [4 /*yield*/, this.updateModels()];
                    case 1:
                        _s.sent();
                        _s.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    class_2.prototype.provideScore = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_s) {
                // TODO I think we have to check if it's hosted or not to expose this function
                if (!this.pieContentModel || !this.pieContentModel.models) {
                    console.error("No pie content model");
                    return [2 /*return*/, false];
                }
                return [2 /*return*/, Promise.all((this.pieContentModel.models || []).map(function (model) { return __awaiter(_this, void 0, void 0, function () {
                        var pieEl, session, controller, _s, _t, _u;
                        return __generator(this, function (_v) {
                            switch (_v.label) {
                                case 0:
                                    pieEl = this.el.querySelector("[id='" + model.id + "']");
                                    !pieEl && (pieEl = this.el.querySelector("[pie-id='" + model.id + "']"));
                                    session = this.findOrAddSession(this.session.data, model.id);
                                    if (!pieEl) return [3 /*break*/, 2];
                                    controller = this.pieLoader.getController(pieEl.localName);
                                    if (!(controller && controller.outcome)) return [3 /*break*/, 2];
                                    _t = (_s = Object).assign;
                                    _u = [Object.assign({}, session)];
                                    return [4 /*yield*/, controller.outcome(model, session, {
                                            mode: "evaluate"
                                        })];
                                case 1: return [2 /*return*/, _t.apply(_s, _u.concat([(_v.sent())]))];
                                case 2: return [2 /*return*/];
                            }
                        });
                    }); }))];
            });
        });
    };
    class_2.prototype.updateModels = function (newEnv) {
        var _this = this;
        if (newEnv === void 0) { newEnv = this.env; }
        // wrapping a player in stimulus layout
        if (this.stimulusPlayer) {
            this.stimulusPlayer.env = newEnv;
            return;
        }
        performance.mark("pie-model-set-start");
        if (this.pieContentModel &&
            this.pieContentModel.models &&
            typeof this.pieContentModel.models.forEach === "function" &&
            this.pieContentModel.markup &&
            this.elementsLoaded) {
            /**
             * Block session changed events while we set model/session on the elements.
             * TODO: The elements should *not* be firing 'session-changed' when the session is set.
             * They should only fire this if a user has made a change. Can we guarantee that?
             */
            this.el.addEventListener(lib_2.TYPE, this.stopEventFromPropagating);
            this.pieContentModel.models.forEach(function (model, index) { return __awaiter(_this, void 0, void 0, function () {
                var pieEl, session, controller, _s, err_5;
                return __generator(this, function (_t) {
                    switch (_t.label) {
                        case 0:
                            if (model && model.error) {
                                this.playerError.emit("error loading question data");
                                throw new Error(model.error);
                            }
                            pieEl = this.el.querySelector("[id='" + model.id + "']");
                            session = this.findOrAddSession(this.session.data, model.id);
                            if (!pieEl) return [3 /*break*/, 11];
                            if (!!this.hosted) return [3 /*break*/, 9];
                            _t.label = 1;
                        case 1:
                            _t.trys.push([1, 7, , 8]);
                            controller = this.pieLoader.getController(pieEl.localName);
                            if (!controller) return [3 /*break*/, 5];
                            if (!(this.addCorrectResponse &&
                                controller.createCorrectResponseSession &&
                                typeof controller.createCorrectResponseSession === "function")) return [3 /*break*/, 3];
                            return [4 /*yield*/, controller.createCorrectResponseSession(model, Object.assign(Object.assign({}, newEnv), { role: "instructor" }))];
                        case 2:
                            session = _t.sent();
                            _t.label = 3;
                        case 3:
                            _s = pieEl;
                            return [4 /*yield*/, controller.model(model, session, newEnv)];
                        case 4:
                            _s.model = _t.sent();
                            return [3 /*break*/, 6];
                        case 5:
                            // no controller provided
                            pieEl.model = model;
                            _t.label = 6;
                        case 6: return [3 /*break*/, 8];
                        case 7:
                            err_5 = _t.sent();
                            this.playerError.emit(controllerErrorMessage + "  -  (" + err_5 + ")");
                            return [3 /*break*/, 8];
                        case 8: return [3 /*break*/, 10];
                        case 9:
                            if (model.error) {
                                this.playerError.emit(controllerErrorMessage + "  -  '" + model.error + "'");
                            }
                            pieEl.model = model;
                            if (this.addCorrectResponse) {
                                this.playerError.emit("add-correct-response cannot be used in hosted environement");
                            }
                            _t.label = 10;
                        case 10:
                            try {
                                pieEl.session = session;
                            }
                            catch (err) {
                                this.playerError.emit("error setting item session value - " + err.message);
                            }
                            _t.label = 11;
                        case 11: return [2 /*return*/];
                    }
                });
            }); });
            performance.mark("pie-model-set-end");
            performance.measure("PIE Model Setup Time", "pie-model-set-start", "pie-model-set-end");
            var modelEntry = performance.getEntriesByName("PIE Model Setup Time")[0];
            var modelDuration = modelEntry ? modelEntry.duration : 0;
            console.log("[PIE Model Setup Time]", modelDuration.toFixed(2), "ms");
            setTimeout(function () {
                /** remove the event blocker - see above */
                _this.el.removeEventListener(lib_2.TYPE, _this.stopEventFromPropagating);
                //TODO: is this needed anymore? maybe it should be using 'model-set' instead of 'session-changed' which is what it was using.
                _this.loadComplete.emit();
            }, 150);
        }
    };
    class_2.prototype.stopEventFromPropagating = function (e) {
        e.stopPropagation();
    };
    class_2.prototype.scopeCSS = function (cssText, customClassname) {
        return cssText.replace(/(^|\})\s*([^{]+)\s*\{/g, function (_, close, selector) {
            var scoped = selector
                .split(",")
                .map(function (s) { return "pie-player." + customClassname + " " + s.trim(); })
                .join(", ");
            return close + " " + scoped + " {";
        });
    };
    class_2.prototype.loadScopedExternalStyle = function (url, customClassname) {
        return __awaiter(this, void 0, void 0, function () {
            var startTime, res, css, fetchEnd, scopeStart, scopedCSS, scopeEnd, styleTag;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        startTime = performance.now();
                        console.log("[style-loader] Fetching CSS: " + url);
                        return [4 /*yield*/, fetch(url)];
                    case 1:
                        res = _s.sent();
                        return [4 /*yield*/, res.text()];
                    case 2:
                        css = _s.sent();
                        fetchEnd = performance.now();
                        console.log("[style-loader] Fetch complete in " + (fetchEnd - startTime).toFixed(2) + "ms");
                        scopeStart = performance.now();
                        scopedCSS = this.scopeCSS(css, customClassname);
                        scopeEnd = performance.now();
                        console.log("[style-loader] CSS scoped in " + (scopeEnd - scopeStart).toFixed(2) + "ms");
                        styleTag = document.createElement("style");
                        styleTag.setAttribute("data-pie-style", url);
                        styleTag.textContent = scopedCSS;
                        document.head.appendChild(styleTag);
                        return [2 /*return*/];
                }
            });
        });
    };
    class_2.prototype.componentWillLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                if (this.config) {
                    this.watchConfig(this.config);
                }
                return [2 /*return*/];
            });
        });
    };
    class_2.prototype.findOrAddSession = function (data, id) {
        var s = data.find(function (d) { return d.id === id; });
        if (s) {
            return s;
        }
        var ss = { id: id };
        data.push(ss);
        return ss;
    };
    class_2.prototype.renderMath = function () {
        mathRenderingAccessible$1.renderMath(this.el);
    };
    class_2.prototype.addBottomBorder = function (tags) {
        if (!Array.isArray(tags)) {
            return;
        }
        tags.forEach(function (tag) {
            var elems = document.querySelectorAll("" + tag);
            for (var _i = 0, elems_1 = elems; _i < elems_1.length; _i++) {
                var elem = elems_1[_i];
                if (elem && elem instanceof HTMLElement) {
                    elem.classList.add("evaluate-bottom-border");
                }
            }
        });
    };
    class_2.prototype.afterRender = function () {
        return __awaiter(this, void 0, void 0, function () {
            var pieTags, elements, loadedInfo, renderEntry, renderDuration, urls;
            var _this = this;
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0:
                        if (!(this.pieContentModel && this.pieContentModel.markup)) return [3 /*break*/, 3];
                        if (!this.elementsLoaded) return [3 /*break*/, 1];
                        this.updateModels();
                        this.renderMath();
                        if (this.showBottomBorder && this.env.mode === "evaluate") {
                            pieTags = this.pieContentModel.elements &&
                                Object.keys(this.pieContentModel.elements);
                            this.addBottomBorder(pieTags);
                        }
                        return [3 /*break*/, 3];
                    case 1:
                        elements = Object.keys(this.pieContentModel.elements).map(function (el) { return ({
                            name: el,
                            tag: el
                        }); });
                        return [4 /*yield*/, this.pieLoader.elementsHaveLoaded(elements)];
                    case 2:
                        loadedInfo = _s.sent();
                        if (loadedInfo.val &&
                            !!loadedInfo.elements.find(function (el) { return _this.pieContentModel.elements[el.name]; })) {
                            this.elementsLoaded = true;
                            if (performance.getEntriesByName("pie-load-end").length > 0) {
                                performance.mark("pie-elements-load-end");
                                performance.measure("PIE Elements Load Time", "pie-load-end", "pie-elements-load-end");
                                renderEntry = performance.getEntriesByName("PIE Elements Load Time")[0];
                                renderDuration = renderEntry ? renderEntry.duration : 0;
                                console.log("[PIE Elements Load + Render Time]", renderDuration.toFixed(2), "ms");
                            }
                        }
                        _s.label = 3;
                    case 3:
                        if (this.externalStyleUrls &&
                            typeof this.externalStyleUrls === "string" &&
                            this.customClassname &&
                            typeof this.customClassname === "string") {
                            urls = this.externalStyleUrls.split(",").map(function (url) { return url.trim(); });
                            urls.forEach(function (url) {
                                if (url &&
                                    typeof url === "string" &&
                                    !document.querySelector("style[data-pie-style=\"" + url + "\"]")) {
                                    _this.loadScopedExternalStyle(url, _this.customClassname);
                                }
                            });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    class_2.prototype.componentDidLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0: return [4 /*yield*/, this.afterRender()];
                    case 1:
                        _s.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_2.prototype.componentDidUpdate = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_s) {
                switch (_s.label) {
                    case 0: return [4 /*yield*/, this.afterRender()];
                    case 1:
                        _s.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_2.prototype.render = function () {
        var _this = this;
        if (this.stimulusItemModel) {
            return this.renderStimulus ? (h("pie-stimulus-layout", { allowedResize: this.allowedResize }, h("div", { slot: "stimulus", class: "player-stimulus-container" }, h("pie-player", { id: "stimulusPlayer", config: this.stimulusItemModel.passage, env: this.env, hosted: this.hosted, session: this.session, ref: function (el) { return (_this.stimulusPlayer = el); }, bundleHost: this.bundleHost, bundleEndpoints: this.bundleEndpoints, class: this.customClassname })), h("div", { slot: "item", class: "player-item-container" }, h("pie-player", { id: "itemPlayer", addCorrectResponse: this.addCorrectResponse, config: this.stimulusItemModel.pie, env: this.env, hosted: this.hosted, session: this.session, bundleHost: this.bundleHost, bundleEndpoints: this.bundleEndpoints, class: this.customClassname })))) : (h("pie-player", { id: "itemPlayer", addCorrectResponse: this.addCorrectResponse, config: this.stimulusItemModel.pie, env: this.env, hosted: this.hosted, session: this.session, bundleEndpoints: this.bundleEndpoints, class: this.customClassname }));
        }
        else {
            if (this.elementsLoaded) {
                return (h("div", { class: "player-container", innerHTML: this.pieContentModel && this.pieContentModel.markup
                        ? this.pieContentModel.markup
                        : "" }));
            }
            return h("pie-spinner", null);
        }
    };
    Object.defineProperty(class_2.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_2, "watchers", {
        get: function () {
            return {
                "addCorrectResponse": ["watchAddCorrectResponse"],
                "config": ["watchConfig"],
                "env": ["updateModels"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_2, "style", {
        get: function () { return ".pie-loading{position:absolute;height:100%;width:100%;background-color:#fff;bottom:0;left:0;right:0;top:0;z-index:9999;opacity:.4}.pie-loading.fixed{position:fixed}.pie-loading:before{-webkit-box-shadow:0 0 35px rgba(63,81,181,.9);box-shadow:0 0 35px rgba(63,81,181,.9);width:50px;height:50px;-moz-animation:spinPulse 1s infinite ease-in-out;-webkit-animation:spinPulse 1s linear infinite;margin:-25px 0 0 -25px}.pie-loading:after,.pie-loading:before{content:\"\";background-color:transparent;border:5px solid rgba(63,81,181,.9);opacity:.9;border-right:5px solid transparent;border-left:5px solid transparent;border-radius:50px;position:absolute;top:50%;left:50%}.pie-loading:after{-webkit-box-shadow:0 0 15px rgba(63,81,181,.9);box-shadow:0 0 15px rgba(63,81,181,.9);width:30px;height:30px;-moz-animation:spinoffPulse 1s infinite linear;-webkit-animation:spinoffPulse 1s linear infinite;margin:-15px 0 0 -15px}\@-webkit-keyframes spinPulse{0%{-webkit-transform:rotate(160deg);transform:rotate(160deg);opacity:0;-webkit-box-shadow:0 0 1px rgba(63,81,181,.9);box-shadow:0 0 1px rgba(63,81,181,.9)}50%{-webkit-transform:rotate(145deg);transform:rotate(145deg);opacity:1}to{-webkit-transform:rotate(-320deg);transform:rotate(-320deg);opacity:0}}\@keyframes spinPulse{0%{-webkit-transform:rotate(160deg);transform:rotate(160deg);opacity:0;-webkit-box-shadow:0 0 1px rgba(63,81,181,.9);box-shadow:0 0 1px rgba(63,81,181,.9)}50%{-webkit-transform:rotate(145deg);transform:rotate(145deg);opacity:1}to{-webkit-transform:rotate(-320deg);transform:rotate(-320deg);opacity:0}}\@-webkit-keyframes spinoffPulse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(1turn);transform:rotate(1turn)}}\@keyframes spinoffPulse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(1turn);transform:rotate(1turn)}}.pie-api-player img{max-width:inherit!important;max-height:inherit!important}.book-title-k5{text-decoration:underline}.book-title{font-style:italic}.block-quote,.text-block{font-family:serif;margin-left:20%;margin-right:20%;margin-top:5px;margin-bottom:5px;width:60%;border:1px solid #000;padding:2px;display:block}.short-quote{font-weight:700}span.short-quote:before{content:open-quote}span.short-quote:after{content:close-quote}.word-callout{text-decoration:underline}.relative-emphasis{text-transform:uppercase}.content-emphasis{font-weight:700;color:red}span.passage-title:before{content:open-quote}span.passage-title:after{content:close-quote}.proper-name,.variable{font-style:italic}.equation-block{text-align:center;margin-left:20%;margin-right:20%;margin-top:5px;margin-bottom:5px;width:60%;padding:2px;display:block}.embedded-error{font-style:italic}div.passage-subtitle,div.passage-title{font-weight:700;text-align:center}div.passage-author{text-align:center}.p-number{float:left;font-size:.85em}.numbered-paragraph{margin-left:36px}\@media print{.kds-noprint,.noprint{display:none}}.abs,.kds-absolute{border-left:1px solid #000;border-right:1px solid #000;padding:0 .3em 0 .3em}.kds-border-1{border:1px solid #000}.kds-border-2{border:2px solid #000}.center,.kds-center{margin:0;text-align:center}.kds-exponent{font-size:85%}.kds-exponent,sup.frac{margin-left:-.4em;position:relative;top:-1.4em}sup.frac{font-size:70%}.kds-fillin{display:inline-block}.fillin,.kds-fillin{border:1px solid #000;margin:0 .2em;padding-left:1em}.fillin{display:inline-block;*display:inline}.kds-font-larger{font-size:larger}.kds-font-smaller{font-size:smaller}table.kds-fraction{border:0;display:inline-block;font-size:85%;margin:0;padding:0;vertical-align:middle}table.kds-fraction>tbody>tr>td.kds-numerator{border-bottom:1px solid #000;border-left:0;border-right:0;border-top:0;text-align:center}table.kds-fraction>tbody>tr>td.kds-denominator{border:0;text-align:center}table.frac{display:inline-block;*display:inline;vertical-align:middle;font-size:85%;border:0;margin:0;padding:0}.frac .nu{border-left:0;border-top:0;border-right:0;border-bottom:1px solid #000;text-align:center}.frac .de{border:0;text-align:center}.kds-hanging-indent{margin:0;padding-left:3em;text-indent:-3em}.kds-image-caption{font-family:Verdana,Arial,sans-serif;text-align:center}.kds-image-left{float:left;margin-right:5px}.kds-image-right{float:right;margin-left:5px}.indent,.kds-indent{text-indent:3em}.kds-nowrap{display:inline-block;white-space:nowrap}.kds-overline{text-decoration:overline}.kds-parentheses{font-family:Arial Narrow,Arial,sans-serif}.kds-parentheses,b.frac{font-size:300%;font-weight:400;position:relative;top:8px}b.frac{font-family:arial narrow}.kds-pi{font-family:Times New Roman,serif;font-size:1.2em}.newradical{border-collapse:collapse;display:inline-block;*display:inline;vertical-align:middle}.newradical td{border:0;padding:0;vertical-align:top}.newradical td.vinculum{border-top:1px solid #000;padding:0;vertical-align:top}.newradical div.exp{font-size:.7em;position:relative;left:7px;bottom:5px}.kds-underline,.under{text-decoration:underline}.kds-verdana2t,.Verdana2t{border:1px solid #fff;text-align:left;text-decoration:none;vertical-align:top}.kds-whole-number{display:inline-block}.kds-whole-number,.whole{font-size:120%;margin:0 0 0 .2em}.whole{display:inline-block;*display:inline}table.KdsTable01{border:1px solid #000;border-collapse:collapse;border-spacing:0}table.KdsTable01>tbody>tr>th{font-weight:400}table.KdsTable01>tbody>tr>th,table.KdsTable01>tbody>tr>th.bold{background-color:#d3d3d3;border:1px solid #000;padding:2px;text-align:center}table.KdsTable01>tbody>tr>th.bold{font-weight:700}table.KdsTable01>tbody>tr>td,table.KdsTable01>tbody>tr>td.bold{border:1px solid #000;padding:2px;text-align:center}table.KdsTable01>tbody>tr>td.bold{font-weight:700}table.KdsTable02{border:1px solid #000;border-collapse:collapse;border-spacing:0}table.KdsTable02>tbody>tr>th{background-color:#d3d3d3;font-weight:400}table.KdsTable02>tbody>tr>td,table.KdsTable02>tbody>tr>th{border:1px solid #000;padding:2px}.table{width:100%;margin-bottom:1em;background-color:transparent;border-collapse:collapse}.table td,.table th{padding:.75em;vertical-align:top;border-top:1px solid #dee2e6}.table tbody+tbody{border-top:2px solid #dee2e6}.table thead th{vertical-align:bottom;border-bottom:2px solid #dee2e6}th{text-align:inherit}.table-bordered,.table-bordered td,.table-bordered th{border:1px solid #dee2e6}.table-bordered thead td,.table-bordered thead th{border-bottom-width:2px}.table-striped tbody tr:nth-of-type(odd){background-color:rgba(0,0,0,.05)}.text-center{text-align:center!important}.h5,h5{font-size:1.25em}h1,h2,h3,h4,h5,h6{margin-top:0}.h1,.h2,.h3,.h4,.h5,.h6,h1,h2,h3,h4,h5,h6{margin-bottom:.5em;font-family:inherit;font-weight:500;line-height:1.2;color:inherit}.lrn_feature h3{margin-top:0!important}#item,#stimulus{width:50%;float:left}.lrn_width_auto.table{width:auto}.TEX-S3{font-family:MJXZERO,MJXTEX-S3!important}.TEX-S2{font-family:MJXZERO,MJXTEX-S2!important}.TEX-S1{font-family:MJXZERO,MJXTEX-S1!important}.TEX-I{font-family:MJXZERO,MJXTEX-I!important}mjx-c.mjx-c2032{font-family:CerebriSans,serif!important}mjx-c.mjx-c22,mjx-c.mjx-c27{font-family:MJXZERO,serif!important}table{border-collapse:collapse}.evaluate-bottom-border>:first-child:after{content:\"\";display:block;border-bottom:1px solid #d3d3d3}"; },
        enumerable: true,
        configurable: true
    });
    return class_2;
}());
var PieSpinner = /** @class */ (function () {
    function PieSpinner(hostRef) {
        registerInstance(this, hostRef);
        /**
         * Shows the spinner
         */
        this.active = true;
    }
    PieSpinner.prototype.render = function () {
        return (h("div", null, !this.active && h("slot", null), this.active ?
            h("div", { id: "pie-spinner-container" }, h("div", { id: "pie-spinner" }, h("svg", { class: "lds-spinner", width: "200px", height: "200px", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 100 100", preserveAspectRatio: "xMidYMid" }, h("g", { transform: "rotate(0 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-1.1916666666666667s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(30 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-1.0833333333333333s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(60 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.9750000000000001s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(90 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.8666666666666667s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(120 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.7583333333333333s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(150 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.65s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(180 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.5416666666666666s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(210 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.43333333333333335s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(240 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.325s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(270 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.21666666666666667s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(300 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "-0.10833333333333334s", repeatCount: "indefinite" }))), h("g", { transform: "rotate(330 50 50)" }, h("rect", { x: "47", y: "22.5", rx: "9.4", ry: "4.5", width: "6", height: "15", fill: "#677179" }, h("animate", { attributeName: "opacity", values: "1;0", keyTimes: "0;1", dur: "1.3s", begin: "0s", repeatCount: "indefinite" }))))))
            :
                h("div", null)));
    };
    Object.defineProperty(PieSpinner, "style", {
        get: function () { return "#pie-spinner-container{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;width:100%}#pie-spinner{max-width:50%}"; },
        enumerable: true,
        configurable: true
    });
    return PieSpinner;
}());
var PieStimulusLayout = /** @class */ (function () {
    function PieStimulusLayout(hostRef) {
        registerInstance(this, hostRef);
        // shows if resizing is activated or not
        this.allowedResize = false;
        // shows if user is currently resizing the component,
        this.isResizing = false;
        // the initial X-coordinate of the mouse cursor.
        this.initialX = 0;
        //  flex values of the left component
        this.initialLeftFlex = 0.5;
        //  flex values of the right component as the user resizes them
        this.initialRightFlex = 0.5;
    }
    PieStimulusLayout.handleElements = function () {
        var el = document.querySelector('#pie-stimulus-container');
        if (el) {
            var boundRect = el.getBoundingClientRect();
            el.style.height = "calc(100vh - " + boundRect.top + "px";
        }
    };
    PieStimulusLayout.prototype.componentDidRender = function () {
        PieStimulusLayout.handleElements();
    };
    PieStimulusLayout.prototype.componentDidLoad = function () {
        var _this = this;
        PieStimulusLayout.handleElements();
        if (this.allowedResize) {
            this.resizer.addEventListener('mousedown', function (e) {
                _this.isResizing = true;
                _this.initialX = e.clientX;
            });
            window.addEventListener('mousemove', this.handleMouseMove.bind(this));
            this.resizer.addEventListener('mouseup', this.handleMouseUp.bind(this));
        }
        this.readMoreButton.addEventListener("click", function () { return _this.handleReadMore(); });
    };
    PieStimulusLayout.prototype.componentDidUpdate = function () {
        PieStimulusLayout.handleElements();
    };
    PieStimulusLayout.prototype.componentDidUnload = function () {
        if (this.allowedResize) {
            window.removeEventListener('mousemove', this.handleMouseMove.bind(this));
            this.resizer.removeEventListener('mouseup', this.handleMouseUp.bind(this));
        }
    };
    PieStimulusLayout.prototype.handleReadMore = function () {
        if (this.readMoreButton.innerHTML.includes('Read More')) {
            this.stimulus.style.flex = '1';
            this.readMoreButton.innerHTML = "Read Less <span class=arrow-up>&#9650;</span>";
            this.stimulus.style.overflow = 'auto';
            this.stimulus.classList.remove('truncated');
        }
        else {
            this.readMoreButton.innerHTML = "Read More <span class=arrow-down>&#9660;</span>";
            this.stimulus.style.flex = '0 0 30%';
            this.stimulus.style.overflow = 'hidden';
            this.stimulus.scrollTop = 0;
            this.stimulus.classList.add('truncated');
        }
    };
    PieStimulusLayout.prototype.handleMouseMove = function (e) {
        if (this.isResizing && this.allowedResize) {
            var deltaX = e.clientX - this.initialX;
            var containerWidth = this.resizer.parentElement.clientWidth;
            var newLeftFlex = (containerWidth * this.initialLeftFlex + deltaX) / containerWidth;
            var newRightFlex = 1 - newLeftFlex;
            if (newLeftFlex >= 0 && newRightFlex >= 0 && newLeftFlex <= 1 && newRightFlex <= 1) {
                this.initialLeftFlex = newLeftFlex;
                this.initialRightFlex = newRightFlex;
                // Update the initial cursor position
                this.initialX = e.clientX;
            }
        }
    };
    PieStimulusLayout.prototype.handleMouseUp = function () {
        this.isResizing = false;
    };
    // add style when the containers are resizable
    PieStimulusLayout.prototype.getStyle = function (flex) {
        var viewPortWidth = window.innerWidth;
        // avoid this style for viewports < 1020
        if (this.allowedResize && viewPortWidth > 1020) {
            return { flex: "" + flex, transition: this.isResizing ? 'none' : 'flex 0.1s ease' };
        }
        return {};
    };
    PieStimulusLayout.prototype.render = function () {
        var _this = this;
        return (h("div", { id: "pie-stimulus-container" }, h("div", { id: "stimulus", class: "truncated", ref: function (el) { return _this.stimulus = el; }, style: this.getStyle(this.initialLeftFlex) }, h("slot", { name: 'stimulus' })), h("button", { id: "read-more", ref: function (el) { return _this.readMoreButton = el; } }, "Read More", h("span", { class: "arrow-down" }, "\u25BC")), this.allowedResize &&
            h("div", { id: "resizer", ref: function (el) { return (_this.resizer = el); } }), h("div", { id: "item", style: this.getStyle(this.initialRightFlex) }, h("slot", { name: 'item' }))));
    };
    Object.defineProperty(PieStimulusLayout, "style", {
        get: function () { return "#pie-stimulus-container{display:-ms-flexbox;display:-webkit-flex;display:flex;-webkit-flex-direction:row;-ms-flex-direction:row;flex-direction:row;-webkit-flex-wrap:nowrap;-ms-flex-wrap:nowrap;flex-wrap:nowrap;-webkit-justify-content:flex-start;-ms-flex-pack:start;justify-content:flex-start;-webkit-align-content:stretch;-ms-flex-line-pack:stretch;align-content:stretch;-webkit-align-items:flex-start;-ms-flex-align:start;align-items:flex-start;overflow:hidden}#pie-stimulus-container #stimulus{-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:1;-ms-flex:1;flex:1;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto;height:100%;overflow:scroll}#pie-stimulus-container #read-more{display:none}#pie-stimulus-container #item{-webkit-order:0;-ms-flex-order:0;order:0;-webkit-flex:1;-ms-flex:1;flex:1;-webkit-align-self:auto;-ms-flex-item-align:auto;align-self:auto;height:100%;overflow:scroll}#pie-stimulus-container #resizer{width:5px;cursor:ew-resize;background-color:transparent;height:100%;-webkit-transition:width .2s ease-in-out,background-color .2s ease-in-out;transition:width .2s ease-in-out,background-color .2s ease-in-out}#pie-stimulus-container #resizer:active,#pie-stimulus-container #resizer:hover{background-color:#add8e6;cursor:ew-resize}\@media screen and (max-width:1020px){#pie-stimulus-container{-ms-flex-direction:column;flex-direction:column}#resizer{display:none}#pie-stimulus-container #stimulus{width:100%;overflow:hidden;position:relative;-ms-flex:0 0 30%;flex:0 0 30%}#pie-stimulus-container #item{width:100%;overflow:auto;-ms-flex:1;flex:1}#pie-stimulus-container #stimulusPlayer{opacity:1;-webkit-transition:opacity .3s;transition:opacity .3s}#pie-stimulus-container #stimulus.truncated:after{content:\"\";position:absolute;bottom:0;right:0;left:0;height:50px;background:-webkit-gradient(linear,left top,left bottom,from(hsla(0,0%,100%,0)),to(#fff));background:linear-gradient(hsla(0,0%,100%,0),#fff)}#pie-stimulus-container #read-more{display:block;margin-top:10px;cursor:pointer;-ms-flex-item-align:center;align-self:center;border:none;background-color:transparent;color:#6495ed}}"; },
        enumerable: true,
        configurable: true
    });
    return PieStimulusLayout;
}());
export { ErrorMessage as error_message, PieApiPlayer as pie_api_player, Player as pie_player, PieSpinner as pie_spinner, PieStimulusLayout as pie_stimulus_layout };
