import { r as registerInstance, h, d as getElement } from './core-80804c5e.js';
var TokenHelper = /** @class */ (function () {
    function TokenHelper(hostRef) {
        registerInstance(this, hostRef);
    }
    TokenHelper.prototype.receiveToken = function (e) {
        this.token = e.detail;
    };
    TokenHelper.prototype.connectedCallback = function () {
        console.log("connected..");
        var p = new URLSearchParams(document.location.search);
        if (p.has("token")) {
            this.token = p.get("token");
        }
    };
    TokenHelper.prototype.componentDidUpdate = function () {
        console.log("componentDidUpdate..");
        this.applyToken();
    };
    TokenHelper.prototype.componentDidLoad = function () {
        console.log("componentDidLoad..");
        this.applyToken();
    };
    TokenHelper.prototype.applyToken = function () {
        var _this = this;
        if (!this.token) {
            return;
        }
        var params = new URLSearchParams(document.location.search);
        if (!params.has("token")) {
            params.append("token", this.token);
            var u = document.location.href + "?" + params.toString();
            window.history.replaceState({}, document.title, u);
        }
        var a = this.el.querySelectorAll("pie-api-author");
        if (a.length > 0) {
            a.forEach(function (el) {
                el.token = _this.token;
                // el.load();
            });
        }
        var p = this.el.querySelectorAll("pie-api-player");
        if (p.length > 0) {
            p.forEach(function (el) {
                console.log("el:", el);
                el.token = _this.token;
                console.log("el:", el);
            });
        }
    };
    TokenHelper.prototype.render = function () {
        var _this = this;
        return this.token ? (h("slot", null)) : (h("enter-token", { onToken: function (e) { return _this.receiveToken(e); } }));
    };
    Object.defineProperty(TokenHelper.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return TokenHelper;
}());
export { TokenHelper as token_helper };
