var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
function unwrapExports(x) {
    return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}
function createCommonjsModule(fn, module) {
    return module = { exports: {} }, fn(module, module.exports), module.exports;
}
var RE_SCOPED = /^(@[^/]+\/[^/@]+)(?:\/([^@]+))?(?:@([\s\S]+))?/;
var RE_NORMAL = /^([^/@]+)(?:\/([^@]+))?(?:@([\s\S]+))?/;
var parsePackageName = function (input) {
    if (typeof input !== 'string') {
        throw new TypeError('Expected a string');
    }
    var matched = input.charAt(0) === '@' ? input.match(RE_SCOPED) : input.match(RE_NORMAL);
    if (!matched) {
        throw new Error("[parse-package-name] \"" + input + "\" is not a valid string");
    }
    return {
        name: matched[1],
        path: matched[2] || '',
        version: matched[3] || ''
    };
};
// prefix new tag with pp- for pie player and to ensure custom element validity
var createTag = function (npmPkg) { return "pp-" + packageToElementName(npmPkg); };
/**
 * Replaces all user-defined element name mappings with ones derived from
 * the NPM package name.
 * @param content the content to normalize
 */
var normalizeContentElements = function (content) {
    if (!content || (content && !content.elements))
        return content;
    var markup = content.markup;
    Object.keys(content.elements).forEach(function (key) {
        var tag = key;
        var npmPkg = content.elements[key];
        var newTag = createTag(npmPkg);
        // markup = markup.split(tag).join(newTag); // - with this approach, not only html tags are replaced, but also the text
        markup = markup
            .split("<" + tag)
            .join("<" + newTag)
            .split("</" + tag)
            .join("</" + newTag);
        if (content.models) {
            content.models.forEach(function (model) {
                if (model.element === key) {
                    model.element = newTag;
                }
            });
        }
        if (key !== newTag) {
            content.elements[newTag] = npmPkg;
            delete content.elements[key];
        }
    });
    content.markup = markup;
    return content;
};
/**
 * Convert an npm package to html valid element name by replacing
 * all special chars with `-`
 * @param npmPackage npm package to convert
 */
var packageToElementName = function (npmPackage) {
    var parsed = parsePackageName(npmPackage);
    if (parsed) {
        var tag = parsed.name.replace(/\/|\./g, "-");
        tag = tag.replace("@", "");
        return tag;
    }
};
var getPackageWithoutVersion = function (packages) {
    var packagesArray = packages.split("+");
    var newPackageArray = [];
    packagesArray.forEach(function (p) { return newPackageArray.push(parsePackageName(p).name); });
    return newPackageArray.join("+");
};
/**
 * See if the `PieContent.elements` set contains the provided package.
 *
 * @param elements the elements dict
 * @param npmPackage the npm package to locate
 */
var elementsHasPackage = function (elements, npmPackage) {
    if (elements) {
        var packageToFind_1 = parsePackageName(npmPackage).name;
        return Object.values(elements).find(function (val) { return packageToFind_1 === parsePackageName(val).name; })
            ? true
            : false;
    }
    else {
        return false;
    }
};
/**
 * Gets all models defined for a given npmPacakge in `PieContent`
 * @param pieContent the pie content
 * @param npmPackage npm package name
 */
var modelsForPackage = function (pieContent, npmPackage) {
    if (pieContent && pieContent.models && pieContent.elements && npmPackage) {
        var element_1 = elementForPackage(pieContent, npmPackage);
        return pieContent.models.filter(function (m) {
            return element_1 === m.element;
        });
    }
    else {
        return [];
    }
};
/**
 * Gets the element tag defined for a package.
 * @param pieContent the pie content
 * @param npmPackage npm package name
 */
var elementForPackage = function (pieContent, npmPackage) {
    var elems = pieContent && pieContent.elements
        ? Object.keys(pieContent.elements).filter(function (elTag) {
            var pkg = pieContent.elements[elTag];
            return parsePackageName(npmPackage).name === parsePackageName(pkg).name;
        })
        : [];
    if (elems.length > 1) {
        throw new Error("invalid item format: multiple elements for package.");
    }
    else {
        return elems[0];
    }
};
var getPackageBundleUri = function (pies) {
    return encodeURI(Object.values(pies).join("+"));
};
var pieContentFromConfig = function (config) {
    try {
        if (typeof config == "string") {
            config = JSON.parse(config);
        }
        if (config.pie) {
            var ac = config;
            return normalizeContentElements(ac.pie);
        }
        else if (config.elements) {
            var pc = config;
            return normalizeContentElements(pc);
        }
        else {
            console.warn("invalid pie data model: " + JSON.stringify(config));
            return null;
        }
    }
    catch (err) {
        console.warn("invalid pie model: " + JSON.stringify(config));
        return null;
    }
};
var patchMDCSwitchFocus = function (element) {
    var lock = 0;
    element.addEventListener("mouseup", function (e) {
        if (lock)
            return;
        var target = e.target;
        do {
            if (target.classList &&
                target.classList.contains("mdc-ripple-upgraded--background-focused")) {
                lock++;
                target.classList.remove("mdc-ripple-upgraded--background-focused");
                lock--;
                return;
            }
        } while ((target = target.parentNode));
    }, { passive: true });
};
/**
 * Creates short id for use within pie models.
 * Can be used to create random element tag or model id.
 */
var pieShortIdGenerator = function () {
    // Not an advanced algorighm, but only need to be unique within the current model.
    var S4 = function () {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    };
    return "p-" + (S4() + S4());
};
/**
 * Wait for the given milliseconds.
 * @param ms
 */
var waitFor = function (ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
};
/**
 * Execute an async function and retry with exponential backoff
 * based on the maximum retry attempts it can perform.
 *
 * @param fn: Promise-returning function to retry.
 * @param maxRetries: The maximum number of times to attempt the function.
 * @param delay: The delay, in milliseconds.
 */
var withRetry = function (fn, maxRetries, delay, maxDelay) {
    if (delay === void 0) { delay = 100; }
    var retryWithBackoff = function (retries) { return __awaiter(void 0, void 0, void 0, function () {
        var currentDelay, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 4, , 5]);
                    currentDelay = 0;
                    if (!(retries > 0)) return [3 /*break*/, 2];
                    // on every retry, exponentially increase the time to wait
                    currentDelay = Math.pow(2, retries) * delay;
                    if (maxDelay && maxDelay < currentDelay) {
                        currentDelay = maxDelay;
                    }
                    return [4 /*yield*/, waitFor(currentDelay)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [4 /*yield*/, fn(currentDelay, retries)];
                case 3: return [2 /*return*/, _a.sent()];
                case 4:
                    err_1 = _a.sent();
                    // retry if the limit isn't reached, otherwise throw the error
                    if (retries < maxRetries) {
                        return [2 /*return*/, retryWithBackoff(retries + 1)];
                    }
                    else {
                        console.info("[retryWithBackoff] Max retries reached.");
                        throw err_1;
                    }
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    }); };
    return retryWithBackoff(0);
};
export { commonjsGlobal as a, elementsHasPackage as b, createCommonjsModule as c, pieShortIdGenerator as d, elementForPackage as e, getPackageBundleUri as f, getPackageWithoutVersion as g, pieContentFromConfig as h, createTag as i, patchMDCSwitchFocus as j, modelsForPackage as m, normalizeContentElements as n, parsePackageName as p, unwrapExports as u, withRetry as w };
