import { r as registerInstance, c as createEvent, h } from './core-213084b6.js';

const EnterToken = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.token = createEvent(this, "token", 7);
    }
    onChange(e) {
        this.value = e.target.value;
        console.log(this.value);
    }
    onKeyDown(ev) {
        if (ev.key === "Enter") {
            this.submit();
        }
    }
    submit() {
        if (this.value && this.value.length > 0) {
            this.token.emit(this.value);
        }
    }
    componentDidLoad() {
        setTimeout(() => {
            this.textarea.focus();
        }, 100);
    }
    render() {
        return (h("div", null, h("h5", null, "Enter your token"), h("textarea", { class: "ta", ref: (r) => (this.textarea = r), value: this.value, onInput: (e) => this.onChange(e), onKeyDown: (e) => this.onKeyDown(e) }), h("br", null), h("br", null), h("input", { type: "submit", onClick: () => this.submit() }, "GO")));
    }
    static get style() { return ".ta {\n  min-width: 500px;\n  min-height: 300px;\n}"; }
};

export { EnterToken as enter_token };
