import { NewRelicEnabledClient } from "./new-relic";
/** Note: lifted form pie-player-components, need to figure out how to export it from that pkg. */
export interface ExternalImageSupport {
    insert(file: File, done: (e: Error | null, src: string) => void, progress?: (percent: number, bytes: number, total: number) => void): any;
    delete(src: string, done: (e?: Error) => void): any;
}
export declare class PieApiImageSupport extends NewRelicEnabledClient implements ExternalImageSupport {
    private token;
    private graphql;
    private versionedID;
    private readonly versionedIDGenerator;
    private readonly fetchUtils;
    constructor(token: string, graphql: string, versionedID?: string, versionedIDGenerator?: () => string);
    protected getTrackingBaseAttributes(): Record<string, any>;
    insert(file: File, done: (e: Error | null, src: string) => void): Promise<void>;
    private createUploadRequest;
    delete(src: string, done: (e?: Error) => void): Promise<void>;
}
