export declare const mockLoadResult: () => {
    data: {
        contentItem: {
            config: {
                id: string;
                elements: {
                    "pie-multiple-choice": string;
                };
                models: {
                    id: string;
                    element: string;
                }[];
                markup: string;
            };
        };
    };
};
export declare const mockAllSanctionedBuildVersions: () => {
    data: {
        findAllBestVersions: {
            name: string;
            version: string;
        }[];
    };
};
export declare const releaseContentItem: () => {
    data: {
        releaseContentItem: {
            id: string;
            version: {
                major: number;
                minor: number;
                patch: number;
            };
        };
    };
};
export declare const mockSaveResult: () => {
    data: {
        saveContentItem: {
            id: string;
            version: {
                major: number;
                minor: number;
                patch: number;
                prerelease: {
                    tag: string;
                    version: number;
                };
            };
        };
    };
};
export declare const loadPlayerResult: () => {
    session: {
        id: string;
        data: any[];
    };
    js: {
        view: string[];
    };
    item: {
        models: {
            disabled: boolean;
            mode: string;
            prompt: string;
            choiceMode: string;
            shuffle: boolean;
            choices: {
                label: string;
                value: string;
            }[];
            complete: {
                min: number;
            };
            element: string;
            id: string;
        }[];
        elements: {
            "pie-multiple-choice": string;
        };
        id: string;
        markup: string;
    };
};
export declare const loadPlayerResultStimulusItem: () => {
    session: {
        id: string;
        data: any[];
    };
    js: {
        view: string[];
    };
    item: {
        pie: {
            id: string;
            elements: {
                "pie-multiple-choice": string;
            };
            models: {
                id: string;
                element: string;
                prompt: string;
                choiceMode: string;
                keyMode: string;
                choices: ({
                    correct: boolean;
                    value: string;
                    label: string;
                    feedback: {
                        type: string;
                        value: string;
                    };
                } | {
                    value: string;
                    label: string;
                    feedback: {
                        type: string;
                        value: string;
                    };
                    correct?: undefined;
                })[];
                partialScoring: boolean;
                partialScoringLabel: string;
            }[];
            markup: string;
        };
        passage: {
            id: string;
            elements: {
                "pie-passage": string;
            };
            models: {
                id: string;
                element: string;
                title: string;
                content: string;
            }[];
            markup: string;
        };
    };
};
export declare const mockBuildServiceResponse: () => any;
