export declare type VersionedId = {
    id: string;
    version: {
        major: number;
        minor: number;
        patch: number;
        prerelease: {
            tag: string;
            version: string;
        };
    };
};
export declare type MethodAndPath = {
    method: string;
    path: string;
};
export declare type ItemSession = {
    id: string;
    data: any[];
};
export declare type HostEnv = "dev" | "stage" | "prod" | "qa" | "local";
export interface BundleEndpoints {
    buildServiceBase: string;
    bundleBase: string;
}
export declare type ApiEndpoints = {
    host: string;
    bundleBaseUrl: string;
    model: string | MethodAndPath;
    saveSession: string | MethodAndPath;
    score: string | MethodAndPath;
    load: string | MethodAndPath;
};
export declare type PlayerInfo = {
    js: {
        view: string[];
    };
    item: {
        models: any[];
        markup: string;
        id: string;
    };
    session: ItemSession;
};
export declare const jsonHeaders: () => {
    Accept: string;
    "Content-Type": string;
};
export declare enum Mode {
    view = "view",
    gather = "gather",
    evaluate = "evaluate"
}
export declare enum Role {
    student = "student",
    instructor = "instructor"
}
export declare type Env = {
    mode: Mode | String;
    role: Role | String;
    partialScoring?: boolean;
};
